/*
pGina ldapAuth code - based upon skeleton code for pGina plugin development
Copyright (C) 2002 Micah Cooper

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Email: coopermj@muohio.edu
Snail Mail:
	Micah Cooper
	212A Kreger Hall
	Miami University
	Oxford OH  45056
*/
// ConfigDialog.cpp : implementation file
//

#include "stdafx.h"
#include "PostgreSQLAuthGina.h"
#include "ConfigDialog.h"


// CConfigDialog dialog

IMPLEMENT_DYNAMIC(CConfigDialog, CDialog)
CConfigDialog::CConfigDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CConfigDialog::IDD, pParent)
	, m_version(POSTGRESQLAUTHVERSION)
	, m_server(_T(""))
	, m_ldapPrePend(_T(""))
	, m_ldapAppend(_T(""))
	, m_ldapAdminUsername(_T(""))
	, m_ldapAdminPassword(_T(""))
	, m_useSSL(FALSE)
	, m_port(_T(""))
	, m_ldapFilter(_T(""))
	, m_ldapGroupAttr(_T(""))
	, m_searchMode(FALSE)
	, m_multiMap(FALSE)
	, m_mapMode(FALSE)
	, m_newContext(_T(""))
	, m_NewAdmin(_T(""))
	, m_newUser(_T(""))
{
	CString temp;
	m_server = regReadString(L"ldapServer");	
	m_ldapPrePend = regReadString(L"ldapPrePend");
	m_ldapAppend = regReadString(L"ldapAppend");
	m_ldapAdminUsername = regReadString(L"ldapAdminUsername");
	m_ldapAdminPassword = regReadString(L"ldapAdminPassword");
	m_port = regReadString(L"ldapPort");
	m_ldapFilter = regReadString(L"ldapFilter");
	m_ldapGroupAttr = regReadString(L"ldapGroupAttr");

	temp = regReadString(L"useSSL");
	if(temp.GetAt(0) == '1')
		m_useSSL = true;
	else
		m_useSSL = false;
	
	temp = regReadString(L"ldapMethod");
	if(temp.GetAt(0) == '1')
		m_multiMap = true;
	else if(temp.GetAt(0) == '2')
		m_searchMode = true;
	else if(temp.GetAt(0) == '3')
		m_mapMode = true;
	
/*	int method = _wtoi(regReadString(L"ldapMethod"));
	switch(method){
		case 1:	m_multiMap = true;
			break;
		case 2: m_searchMode = true;
			break;
		case 3: m_mapMode = true;
			break;
	} */
	hasLoaded = false;
}

CConfigDialog::~CConfigDialog()
{
//	EnableHtmlHelp();
}

void CConfigDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_VERSION, m_version);
	DDX_Text(pDX, IDC_LDAPSERVER, m_server);
	DDX_Text(pDX, IDC_LDAPPREPEND, m_ldapPrePend);
	DDX_Text(pDX, IDC_LDAPAPPEND, m_ldapAppend);
	DDX_Text(pDX, IDC_ADMINUSERNAME, m_ldapAdminUsername);
	DDX_Text(pDX, IDC_ADMINPASSWORD, m_ldapAdminPassword);
	DDX_Check(pDX, IDC_USESSL, m_useSSL);
	DDX_Text(pDX, IDC_PORT, m_port);
	DDX_Text(pDX, IDC_LDAPFILTER, m_ldapFilter);
	DDX_Text(pDX, IDC_LDAPGROUPATTR, m_ldapGroupAttr);
	DDX_Check(pDX, IDC_SEARCH, m_searchMode);
	DDX_Check(pDX, IDC_MULTIMAP, m_multiMap);
	DDX_Check(pDX, IDC_MAP, m_mapMode);
	DDX_Control(pDX, IDC_CONTEXTLIST, m_ContextList);
	DDX_Text(pDX, IDC_NEWCONTEXT, m_newContext);
	DDX_Control(pDX, IDC_CONTEXTLIST2, m_AdminList);
	DDX_Text(pDX, IDC_NEWCONTEXT2, m_NewAdmin);
	DDX_Control(pDX, IDC_CONTEXTLIST3, m_UserList);
	DDX_Text(pDX, IDC_NEWCONTEXT3, m_newUser);
	if(!hasLoaded)
	{
		loadListsFromReg();
		hasLoaded = true;
	}

}


BEGIN_MESSAGE_MAP(CConfigDialog, CDialog)
	ON_BN_CLICKED(IDOK, OnSave)
	ON_BN_CLICKED(IDC_SEARCH, OnChangeSearch)
	ON_BN_CLICKED(IDC_MULTIMAP, OnChangeMultimap)
	ON_BN_CLICKED(IDC_MAP, OnChangeMapMode)
	ON_BN_CLICKED(IDC_ADDCONTEXTBUTTON, OnAddContext)
	ON_BN_CLICKED(IDC_MOVECTXUP, OnMoveContextUp)
	ON_BN_CLICKED(IDC_MOVECTXDWN, OnMoveContextDown)
	ON_BN_CLICKED(IDC_ADDCONTEXTBUTTON2, OnAddAdmin)
	ON_BN_CLICKED(IDC_ADDCONTEXTBUTTON3, OnAddNewUser)
	ON_BN_CLICKED(IDC_MOVECTXUP2, OnRemoveContext)
	ON_BN_CLICKED(IDC_MOVECTXUP3, OnRemoveAdmin)
	ON_BN_CLICKED(IDC_MOVECTXUP4, OnRemoveUser)
	ON_LBN_SELCHANGE(IDC_CONTEXTLIST2, OnLbnSelchangeContextlist2)
	ON_BN_CLICKED(IDHELP, OnBnClickedHelp)
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CMDIFrameWnd::OnHelpFinder)
//	ON_COMMAND(ID_HELP, CMDIFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CMDIFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CMDIFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()

void CConfigDialog::OnSave()
{
	// TODO: Add your control notification handler code here
	//OnOK();
	UpdateData(TRUE);

	// Save data to registry
	CString temp;

	if(m_server.GetLength() > 0)
		regWriteString(m_server.GetBuffer(m_server.GetLength()),L"ldapServer");
	
	if(m_ldapPrePend.GetLength() > 0)
		regWriteString(m_ldapPrePend.GetBuffer(m_ldapPrePend.GetLength()),L"ldapPrePend");

	if(m_ldapAppend.GetLength() > 0)
		regWriteString(m_ldapAppend.GetBuffer(m_ldapAppend.GetLength()),L"ldapAppend");

	if(m_ldapAdminUsername.GetLength() > 0)
        regWriteString(m_ldapAdminUsername.GetBuffer(m_ldapAdminUsername.GetLength()),L"ldapAdminUsername");
	
	if(m_ldapAdminPassword.GetLength() > 0)
		regWriteString(m_ldapAdminPassword.GetBuffer(m_ldapAdminPassword.GetLength()),L"ldapAdminPassword");
	
	if(m_port.GetLength() > 0)
		regWriteString(m_port.GetBuffer(m_port.GetLength()),L"ldapPort");
	
	if(m_ldapFilter.GetLength() > 0)
		regWriteString(m_ldapFilter.GetBuffer(m_ldapFilter.GetLength()),L"ldapFilter");
	
	if(m_ldapGroupAttr.GetLength() > 0)
		regWriteString(m_ldapGroupAttr.GetBuffer(m_ldapGroupAttr.GetLength()),L"ldapGroupAttr");

	if(m_useSSL)
		regWriteString(TEXT("1"),L"useSSL");
	else
		regWriteString(TEXT("0"),L"useSSL");

	if(m_multiMap)
		regWriteString(TEXT("1"),L"ldapMethod");

	if(m_searchMode)
		regWriteString(TEXT("2"),L"ldapMethod");

	if(m_mapMode)
		regWriteString(TEXT("3"),L"ldapMethod");
		
	saveListsToReg();
	MessageBox(TEXT("Settings Saved"),TEXT("Saved"),MB_OK);
}

void CConfigDialog::OnChangeSearch()
{
	// TODO: Add your control notification handler code here
	 //m_searchMode
	 //m_multiMap
	//m_mapMode
	UpdateData(TRUE);
	if(m_searchMode)
	{
		m_multiMap = false;
		m_mapMode = false;
	}
	if(!m_searchMode) // if they try to uncheck it
		m_searchMode = true; // dont let them
	UpdateData(FALSE);
}

void CConfigDialog::OnChangeMultimap()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_multiMap)
	{
		m_searchMode = false;
		m_mapMode = false;
	}
	if(!m_multiMap) // if they try to uncheck it
		m_multiMap = true; // dont let them
	
	UpdateData(FALSE);
}

void CConfigDialog::OnChangeMapMode()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_mapMode)
	{
		m_searchMode = false;
		m_multiMap = false;
	}
	if(!m_mapMode) // if they try to uncheck it
		m_mapMode = true; // dont let them
	
	UpdateData(FALSE);
}

void CConfigDialog::OnAddContext()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_ContextList.AddString(m_newContext);
	m_newContext = TEXT("");
	UpdateData(FALSE);
}

void CConfigDialog::OnMoveContextUp()
{
	UpdateData(TRUE);
	// TODO: Add your control notification handler code here
	if(m_ContextList.GetCurSel() > 0)
		swapItem(&m_ContextList,m_ContextList.GetCurSel(),m_ContextList.GetCurSel() - 1);

	UpdateData(FALSE);
}

void CConfigDialog::OnMoveContextDown()
{
	UpdateData(TRUE);
	// TODO: Add your control notification handler code here
	if(m_ContextList.GetCurSel() >= 0 && m_ContextList.GetCurSel() < m_ContextList.GetCount() - 1)
		swapItem(&m_ContextList,m_ContextList.GetCurSel(),m_ContextList.GetCurSel() + 1);

	UpdateData(FALSE);
}

void CConfigDialog::OnAddAdmin()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_AdminList.AddString(m_NewAdmin);
	m_NewAdmin = TEXT("");
	UpdateData(FALSE);
}


void CConfigDialog::OnAddNewUser()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_UserList.AddString(m_newUser);
	m_newUser = TEXT("");
	UpdateData(FALSE);
}

void CConfigDialog::OnRemoveContext()
{
	// TODO: Add your control notification handler code here
	if(m_ContextList.GetCurSel() >= 0)
		m_ContextList.DeleteString(m_ContextList.GetCurSel());
}

void CConfigDialog::OnRemoveAdmin()
{
	// TODO: Add your control notification handler code here
	if(m_AdminList.GetCurSel() >= 0)
		m_AdminList.DeleteString(m_AdminList.GetCurSel());
}

void CConfigDialog::OnRemoveUser()
{
	// TODO: Add your control notification handler code here
	if(m_UserList.GetCurSel() >= 0)
		m_UserList.DeleteString(m_UserList.GetCurSel());
}

void CConfigDialog::loadListsFromReg(void)
{
	// Load the content for the lists from the registry 
	WCHAR currentName[256];
	int x = 0;
	CString contextValue;
	
	// Do contexts first
	swprintf(currentName,TEXT("ldapContext%d"),x);
	contextValue = regReadString(currentName);
	while(contextValue.GetLength() > 0)
	{
		m_ContextList.AddString(contextValue);
		x++;
        swprintf(currentName,TEXT("ldapContext%d"),x);
		contextValue = regReadString(currentName);
	}
	x = 0;
	// Then adminOKx
	swprintf(currentName,TEXT("adminOK%d"),x);
	contextValue = regReadString(currentName);
	while(contextValue.GetLength() > 0)
	{
		m_AdminList.AddString(contextValue);
		x++;
        swprintf(currentName,TEXT("adminOK%d"),x);
		contextValue = regReadString(currentName);
	}

	x = 0;
	// Then userOKx
	swprintf(currentName,TEXT("userOK%d"),x);
	contextValue = regReadString(currentName);
	while(contextValue.GetLength() > 0)
	{
		m_UserList.AddString(contextValue);
		x++;
        swprintf(currentName,TEXT("userOK%d"),x);
		contextValue = regReadString(currentName);
	}

}

void CConfigDialog::saveListsToReg(void)
{
	WCHAR currentName[256];
	CString value;
	int x = 0;

	// First is contexts, save them
	for(x = 0; x < m_ContextList.GetCount(); x++)
	{
		m_ContextList.GetText(x,value);
		swprintf(currentName,TEXT("ldapContext%d"),x);
		regWriteString(value.GetBuffer(value.GetLength()),currentName);
	}

	// Now loop through and delete any existing contexts above our last saved one
	x = m_ContextList.GetCount();
	swprintf(currentName,TEXT("ldapContext%d"),x);
	value = regReadString(currentName);

	while(value.GetLength() > 0)
	{
		//regDelValue(currentName);
		x++;
		swprintf(currentName,TEXT("ldapContext%d"),x);
		value = regReadString(currentName);
	}

	// Now for admin, save them
	for(x = 0; x < m_AdminList.GetCount(); x++)
	{
		m_AdminList.GetText(x,value);
		swprintf(currentName,TEXT("adminOK%d"),x);
		regWriteString(value.GetBuffer(value.GetLength()),currentName);
	}

	// Now loop through and delete any existing contexts above our last saved one
	x = m_AdminList.GetCount();
	swprintf(currentName,TEXT("adminOK%d"),x);
	value = regReadString(currentName);

	while(value.GetLength() > 0)
	{
		//regDelValue(currentName);
		x++;
		swprintf(currentName,TEXT("adminOK%d"),x);
		value = regReadString(currentName);
	}

	// then users
	for(x = 0; x < m_UserList.GetCount(); x++)
	{
		m_UserList.GetText(x,value);
		swprintf(currentName,TEXT("userOK%d"),x);
		regWriteString(value.GetBuffer(value.GetLength()),currentName);
	}

	// Now loop through and delete any existing contexts above our last saved one
	x = m_UserList.GetCount();
	swprintf(currentName,TEXT("userOK%d"),x);
	value = regReadString(currentName);

	while(value.GetLength() > 0)
	{
		//regDelValue(currentName);
		x++;
		swprintf(currentName,TEXT("userOK%d"),x);
		value = regReadString(currentName);
	}
}

void CConfigDialog::swapItem(CListBox *listbox,int old, int next)
{
	CString valueA;
	CString valueB;
	

	listbox->GetText(old,valueA);
	listbox->DeleteString(old);
	listbox->InsertString(next,valueA);	
	listbox->SetCurSel(next);
}
void CConfigDialog::OnLbnSelchangeContextlist2()
{
	// TODO: Add your control notification handler code here
}

void CConfigDialog::OnBnClickedHelp()
{
	/*DWORD ids[3] ;
     ids[0] = ControlId ;
     ids[1] = HelpId ;
     ids[2] = 0 ;*/

	// TODO: Add your control notification handler code here
	ShellExecute(NULL,NULL,L"ldapauth.chm",NULL,NULL,SW_SHOWNORMAL);
	/*HtmlHelp(
         hwndCTRL,
         "c:\\myHelp.chm::/popups\cshelp.txt",
         HH_TP_HELP_WM_HELP,
         (DWORD) ids) ;*/
	/*HtmlHelp(
         NULL,
         "ldapauth.chm",
         HH_TP_HELP_WM_HELP,
         NULL) ;*/
}
