/*
pGina PostgreSQLAuth code - based upon skeleton code for pGina plugin development
Copyright (C) 2006 Fabien Milcent

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Email: fabien@isihellas.com
*/
#pragma once

#include "Resource.h"
#include "afxwin.h"

// CConfigDialog dialog

class CConfigDialog : public CDialog
{
	DECLARE_DYNAMIC(CConfigDialog)

public:
	CConfigDialog(CWnd* pParent = NULL);   // standard constructor
	virtual ~CConfigDialog();
	void loadListsFromReg(void); // load the lists from the registry
	void saveListsToReg(void); // save the lists to the registry
	// Dialog Data
	enum { IDD = IDD_CONFIGURE_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	// Used to display the LDAPAuth Version
	CString m_version;
	afx_msg void OnSave();
	CString m_server;
	CString m_ldapPrePend;
	CString m_ldapAppend;
	CString m_ldapAdminUsername;
	CString m_ldapAdminPassword;
	BOOL m_useSSL;
	CString m_port;
	CString m_ldapFilter;
	CString m_ldapGroupAttr;
	BOOL m_searchMode;
	afx_msg void OnChangeSearch();
	BOOL m_multiMap;
	afx_msg void OnChangeMultimap();
	BOOL m_mapMode;
	afx_msg void OnChangeMapMode();
	CListBox m_ContextList;
	CString m_newContext;
	afx_msg void OnAddContext();
	afx_msg void OnMoveContextUp();
	afx_msg void OnMoveContextDown();
	CListBox m_AdminList;
	CString m_NewAdmin;
	afx_msg void OnAddAdmin();
	CListBox m_UserList;
	CString m_newUser;
	afx_msg void OnAddNewUser();
	
	afx_msg void OnRemoveContext();
	afx_msg void OnRemoveAdmin();
	afx_msg void OnRemoveUser();
	bool hasLoaded;
	void CConfigDialog::swapItem(CListBox *,int, int);
	afx_msg void OnLbnSelchangeContextlist2();
	//afx_msg void OnBnClickedCancel2();
	afx_msg void OnBnClickedHelp();
};
