// ConfigurationDialog.cpp : implementation file
//

#include "stdafx.h"
#include "PostgreSQLAuthGina.h"
#include "ConfigurationDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConfigurationDialog dialog


IMPLEMENT_DYNAMIC(CConfigurationDialog, CDialog)
CConfigurationDialog::CConfigurationDialog (CWnd* pParent /*=NULL*/)
	: CDialog(CConfigurationDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConfigurationDialog)
	m_HostIP = _T("");
	m_DB = _T("");
	m_Password = _T("");
	m_Password_Field = _T("");
	m_Table = _T("");
	m_Username = _T("");
	m_Username_Field = _T("");
	m_Version = (POSTGRESQLAUTHVERSION);
	m_Port = _T("");
	m_MD5 = FALSE;
	m_IsAdmin_Field = _T("");
	m_AllowChgPwd_Field = _T("");
	m_UserGroups_Field = _T("");
	//}}AFX_DATA_INIT

	m_HostIP            = regReadString (TEXT("host"));
	m_Port              = regReadString (TEXT("port"));
	m_DB                = regReadString (TEXT("db"));
	m_Table             = regReadString (TEXT("table"));
	m_Username          = regReadString (TEXT("username"));
	m_Password          = regReadString (TEXT("password"));
	m_Username_Field    = regReadString (TEXT("user_field"));
	m_Password_Field    = regReadString (TEXT("pass_field"));
	m_IsAdmin_Field     = regReadString (TEXT("isadmin_field"));
	m_UserGroups_Field  = regReadString (TEXT("usergrp_field"));
	m_AllowChgPwd_Field = regReadString (TEXT("allowpwdchg_field"));

	if (regReadDword (TEXT("pass_type")) != 0)
	{
		m_MD5 = true;
	}
}


void CConfigurationDialog::DoDataExchange (CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfigurationDialog)
	DDX_Text(pDX, IDC_HOST_IP, m_HostIP);
	DDX_Text(pDX, IDC_DB, m_DB);
	DDX_Text(pDX, IDC_PWD, m_Password);
	DDX_Text(pDX, IDC_PWD_FIELD, m_Password_Field);
	DDX_Text(pDX, IDC_TABLE, m_Table);
	DDX_Text(pDX, IDC_USER, m_Username);
	DDX_Text(pDX, IDC_USER_FIELD, m_Username_Field);
	DDX_Text(pDX, IDC_VERSION, m_Version);
	DDX_Text(pDX, IDC_PORT, m_Port);
	DDX_Check(pDX, IDC_MD5, m_MD5);
	DDX_Text(pDX, IDC_ISADMIN, m_IsAdmin_Field);
	DDX_Text(pDX, IDC_ALLOWCHGPWD, m_AllowChgPwd_Field);
	DDX_Text(pDX, IDC_USERGROUPS, m_UserGroups_Field);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfigurationDialog, CDialog)
	//{{AFX_MSG_MAP(CConfigurationDialog)
	ON_BN_CLICKED(IDC_CLOSE, OnClose)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfigurationDialog message handlers

void CConfigurationDialog::OnClose () 
{
	// TODO: Add your control notification handler code here
	EndDialog (5);
}

void CConfigurationDialog::OnSave () 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);

	// Save data to registry

	if (m_HostIP.GetLength () > 0)
	{
		regWriteString (m_HostIP.GetBuffer (m_HostIP.GetLength ()), 
						TEXT("host"));
	}
	
	if (m_Port.GetLength () > 0)
	{
		regWriteString (m_Port.GetBuffer (m_Port.GetLength ()), 
						TEXT("port"));
	}
	
	if (m_DB.GetLength () > 0)
	{
		regWriteString (m_DB.GetBuffer (m_DB.GetLength ()), 
						TEXT("db"));
	}
	
	if (m_Table.GetLength () > 0)
	{
		regWriteString (m_Table.GetBuffer (m_Table.GetLength ()), TEXT("table"));
	}
	
	if (m_Username.GetLength () > 0)
	{
		regWriteString (m_Username.GetBuffer (m_Username.GetLength()), 
						TEXT("username"));
	}
	
	if (m_Password.GetLength () > 0)
	{
		regWriteString (m_Password.GetBuffer (m_Password.GetLength ()),
						TEXT("password"));
	}
	
	if (m_Username_Field.GetLength () > 0)
	{
		regWriteString (m_Username_Field.GetBuffer (m_Username_Field.GetLength ()),
						TEXT("user_field"));
	}
	
	if (m_Password_Field.GetLength () > 0)
	{
		regWriteString (m_Password_Field.GetBuffer (m_Password_Field.GetLength ()),
						TEXT("pass_field"));
	}

	if (m_IsAdmin_Field.GetLength () > 0)
	{
		regWriteString (m_IsAdmin_Field.GetBuffer (m_IsAdmin_Field.GetLength ()),
						TEXT("isadmin_field"));
	}

	if (m_UserGroups_Field.GetLength () > 0)
	{
		regWriteString (m_UserGroups_Field.GetBuffer (m_UserGroups_Field.GetLength ()),
						TEXT("usergrp_field"));
	}

	if (m_AllowChgPwd_Field.GetLength () > 0)
	{
		regWriteString (m_AllowChgPwd_Field.GetBuffer (m_AllowChgPwd_Field.GetLength ()),
						TEXT("allowpwdchg_field"));
	}

	if (m_MD5)
	{
		regWriteDword (1, TEXT("pass_type"));
	}
	else
	{
		regWriteDword (0, TEXT("pass_type"));
	}
}
