/*
pGina Slashdot Plugin
Copyright (C) 2003 Nathan Yocom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Email: nate.yocom@xpasystems.com
Web: http://pgina.xpasystems.com
Snail Mail:
  Nathan Yocom 
  9 Evergreen Farms Rd.
  Scarborough, ME 04074
  Phone: 207-450-4948
*/

// HttpTest.h : main header file for the HttpTest DLL
//

#pragma once

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

#define HTTPAUTH_API extern "C" __declspec(dllexport)

typedef struct pGinaInfo {
		LPTSTR pathMSGina;
		LPTSTR pathPlugin;
		LPTSTR pathProfile;
		LPTSTR mapPaths;
		LPTSTR Username;
		LPTSTR Password;
		LPTSTR homeDir;
		BOOL isAdmin;
		BOOL disabled;
		int authType;
		HANDLE hUser;
		LPTSTR userGroups;
		LPTSTR userDescription;
		LPTSTR userFullName;
		BOOL allowPassChange;
		LPTSTR errorString;
		LPTSTR defaultDomain;
		BOOL Reserved3;
		BOOL Reserved4;
} pGinaInfo ;

#define ABOUT_TEXT TEXT("Slashdot Authentication Plugin for pGina - By Nathan Yocom")

// Export these methods... - REQUIRED
HTTPAUTH_API BOOL UserLogin(LPTSTR, LPTSTR,pGinaInfo *);			
HTTPAUTH_API BOOL ChangeUserPassword(LPTSTR,LPTSTR,LPTSTR);
HTTPAUTH_API LPCTSTR AboutPlugin(void);
HTTPAUTH_API void ChangePluginSettings(void);
HTTPAUTH_API void LoginHook(pGinaInfo *);
HTTPAUTH_API void LogoutHook(pGinaInfo *);
HTTPAUTH_API BOOL IsRequired(void);

/** Reads a string from the registry */
TCHAR * regReadString(LPCTSTR);
/** Reads a bool from the registry */
BOOL regReadBool(LPCTSTR);
/** Writes a string to the registry */
BOOL regWriteString(LPTSTR,LPCTSTR);
/** Writes a BOOL to the registry */
BOOL regWriteBool(BOOL,LPCTSTR);
/** Writes a DWORD to the registry */
BOOL regWriteDword(DWORD,LPCTSTR);
DWORD regReadDword(LPCTSTR);

