// LDAPGroupPlugin.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "LDAPGroupPlugin.h"

HINSTANCE ghInstance;

/**
 * Main function, called when DLL is first attached to, we save our handle here.
 */
BOOL WINAPI DllMain(HINSTANCE hInstance,DWORD dwReason,LPVOID lpReserved)
{
	switch(dwReason)					  // Decide why we have entered 
	{
	case DLL_PROCESS_ATTACH:			  // If we entered and are being attached to 
		hInstance = ghInstance;			  // Save our handle
	case DLL_PROCESS_DETACH:

	default: 
		return(TRUE);
	}
}


LDAPGROUPPLUGIN_API BOOL UserLogin(LPTSTR Username, LPTSTR Password,pGinaInfo *settingsInfo) {
	bool authenticated = false;
	LDAPMessage *entry = NULL;
	char *ret = NULL;

	// Connect to the server
	if(connect_to_ldap() == false) {
		settingsInfo->errorString = _tcsdup(_T("Error connecting to server"));
		return false;
	}
	
	// Check the users primary group
	char *primaryGroup = getPrimaryGroup(convert_to_char(Username));
	
	if(isAdmin(primaryGroup)) {
		authenticated = true;
		settingsInfo->isAdmin = true;
	}
	if(isUser(primaryGroup)) {
		authenticated = true;
	}

	// Get the users group list
	LDAPMessage *groupList = GetGroups(convert_to_char(Username));

	// Walk the list, check for membership at each step
	for (entry = ldap_first_entry(ldapConnection, groupList); entry != NULL; entry = ldap_next_entry(ldapConnection, entry)) {
		ret = ldap_get_dn(ldapConnection, entry);
		
		if(ret != NULL) {
			// First see if they are an admin.. if so, set they as admin and authenticated
			if(isAdmin(ret)) {
				settingsInfo->isAdmin = true;
				authenticated = true;
			} 
			
			// Try the user attribute, non-admins, but allowed in
			if(isUser(ret)) {
				authenticated = true;
			}
			
			ldap_memfree( ret );
		}
	}
   
	// Free our search results
	ldap_msgfree(groupList);


	disconnect();
	return authenticated;
}

LDAPGROUPPLUGIN_API BOOL ChangeUserPassword(LPTSTR Username,LPTSTR OldPass,LPTSTR NewPass) {
	return true;
}

LDAPGROUPPLUGIN_API LPCTSTR AboutPlugin(void) {
	return PLUGIN_VERSION;
}

LDAPGROUPPLUGIN_API void ChangePluginSettings(void) {

}

LDAPGROUPPLUGIN_API void LoginHook(pGinaInfo *settingsInfo) {

}

LDAPGROUPPLUGIN_API void LogoutHook(pGinaInfo *settingsInfo) {

}

LDAPGROUPPLUGIN_API BOOL IsRequired(void) {
	return regReadBool(_T("required"));
}

