#ifndef LDAPGROUP_HEADER
#define LDAPGROUP_HEADER

#define LDAPGROUPPLUGIN_API extern "C" __declspec(dllexport)

#include <wchar.h>
#include <tchar.h>
#include <stdio.h>
#include <stdlib.h>
#include <commctrl.h>
#include <ldap.h>

/** Our Plugin Information/Version text */
#define PLUGIN_VERSION _T("LDAPGroup Plugin Version 0.2 for pGina (http://pgina.xpasystems.com) - Nathan Yocom - nate.yocom@xpasystems.com")

/** The pGinaInfo structure (documented seperatly as part of the pGina project or pGina Plugin SDK */
typedef struct pGinaInfo {
		LPTSTR pathMSGina;
		LPTSTR pathPlugin;
		LPTSTR pathProfile;
		LPTSTR mapPaths;
		LPTSTR Username;
		LPTSTR Password;
		LPTSTR homeDir;
		BOOL isAdmin;
		BOOL disabled;
		int authType;
		HANDLE hUser;
		LPTSTR userGroups;
		LPTSTR userDescription;
		LPTSTR userFullName;
		BOOL allowPassChange;
		LPTSTR errorString;
		LPTSTR defaultDomain;
		BOOL Reserved3;
		BOOL Reserved4;
} pGinaInfo ;



LDAPGROUPPLUGIN_API BOOL UserLogin(LPTSTR, LPTSTR,pGinaInfo *);			
LDAPGROUPPLUGIN_API BOOL ChangeUserPassword(LPTSTR,LPTSTR,LPTSTR);
LDAPGROUPPLUGIN_API LPCTSTR AboutPlugin(void);
LDAPGROUPPLUGIN_API void ChangePluginSettings(void);
LDAPGROUPPLUGIN_API void LoginHook(pGinaInfo *);
LDAPGROUPPLUGIN_API void LogoutHook(pGinaInfo *);
LDAPGROUPPLUGIN_API BOOL IsRequired(void);

/** Global holder for our DLL handle */
extern HINSTANCE ghInstance;
/** Global holder for our LDAP connection */
extern LDAP *ldapConnection;

LPTSTR convert_to_wchar(const char *from);
char * convert_to_char(const TCHAR *from);
TCHAR * regReadString(LPCTSTR location);
BOOL regWriteString(LPTSTR value,LPCTSTR location);
BOOL regReadBool(LPCTSTR location);
BOOL regWriteBool(BOOL value,LPCTSTR location);
LDAPMessage *GetGroups(char *username);
char *getPrimaryGroup(char *username);
bool connect_to_ldap(void);
void disconnect(void);
bool isUser(char *group_dn);
bool isAdmin(char *group_dn);

#endif