// MySQLAuth.h : main header file for the MYSQLAUTH DLL
//

#if !defined(AFX_MYSQLAUTH_H__6B08768B_9D67_4937_B7BE_0C4157342918__INCLUDED_)
#define AFX_MYSQLAUTH_H__6B08768B_9D67_4937_B7BE_0C4157342918__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

#define MYSQLAUTH_API extern "C" __declspec(dllexport)
#define ABOUT_TEXT TEXT("MySQL Auth 0.1.9 pGina Plugin by Nathan Yocom, nate.yocom@xpasystems.com")
typedef struct pGinaInfo {
		LPTSTR pathMSGina;
		LPTSTR pathPlugin;
		LPTSTR pathProfile;
		LPTSTR mapPaths;
		LPTSTR Username;
		LPTSTR Password;
		LPTSTR homeDir;
		BOOL isAdmin;
		BOOL disabled;
		int authType;
		HANDLE hUser;
		LPTSTR userGroups;
		LPTSTR userDescription;
		LPTSTR userFullName;
		BOOL allowPassChange;
		LPTSTR errorString;
		LPTSTR defaultDomain;
		BOOL Reserved3;
		BOOL Reserved4;
} pGinaInfo ;


MYSQLAUTH_API BOOL UserLogin(LPTSTR, LPTSTR,pGinaInfo *);			
MYSQLAUTH_API BOOL ChangeUserPassword(LPTSTR,LPTSTR,LPTSTR);
MYSQLAUTH_API LPCTSTR AboutPlugin(void);
MYSQLAUTH_API void ChangePluginSettings(void);
MYSQLAUTH_API void LoginHook(pGinaInfo *);
MYSQLAUTH_API	void LogoutHook(pGinaInfo *);
MYSQLAUTH_API BOOL IsRequired(void);


TCHAR * regReadString(LPCTSTR);
BOOL regWriteString(LPTSTR,LPCTSTR);
BOOL regReadBool(LPCTSTR);
BOOL regWriteBool(BOOL,LPCTSTR);
BOOL regWriteDword(DWORD,LPCTSTR);
DWORD regReadDword(LPCTSTR);

LPTSTR convert_to_wchar(const char *);
char * convert_to_char(const TCHAR *);



/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYSQLAUTH_H__6B08768B_9D67_4937_B7BE_0C4157342918__INCLUDED_)
