/*
MySQL Logging Plugin for pGina
Copyright (C) 2004 Nathan Yocom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Email: nate.yocom@xpasystems.com
Web: http://pgina.xpasystems.com
Snail Mail:
  Nathan Yocom 
  19 Foxwell Drive
  Scarborough, ME 04074
  Phone: 207-450-4948
*/

/**************************************************************************************
 * Development of this plugin was sponsored by the University of Arizona and I would
 *  like to acknowledge there support and thank them for pursuing its creation.
 **************************************************************************************/


#include "stdafx.h"
#include "MySQLLogger.h"
#include "resource.h"
#include <Iphlpapi.h>

BOOL APIENTRY DllMain( HANDLE hModule, 
					   DWORD  ul_reason_for_call, 
					   LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call) {
	case DLL_PROCESS_ATTACH:
		gPluginHandle = hModule;
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
	return TRUE;
}

MYSQLLOG_API BOOL UserLogin(LPTSTR Username, LPTSTR Password, pGinaInfo *settingsInfo) {
	// Always return false, since we are chained with other plugins we need to allow those plugins a chance to auth, but
	//   if they fail, we shouldnt give a 'true' or pGina will think ALL users are good
	return false;
	
	/*
	MYSQL mysql;
	bool retval = true;
	unsigned int port = 3306;
	char *hostname,*username,*password,*database;
	TCHAR *w_hostname,*w_username,*w_password,*w_database;

	hostname=username=password=database=NULL;
	w_hostname=w_username=w_password=w_database=NULL;

	// Check connectivity?
	if (regReadBool(_T("CheckConnection"))) {
		mysql_init(&mysql);

		w_hostname = regReadString(_T("Server"));
		w_username = regReadString(_T("Username"));
		w_password = regReadString(_T("Password"));
		w_database = regReadString(_T("Database"));
		port = regReadDword(_T("Port"));
		hostname = convert_to_char(w_hostname);
		username = convert_to_char(w_username);
		password = convert_to_char(w_password);
		database = convert_to_char(w_database);

		if (!mysql_real_connect(&mysql,hostname,username,password,database,port,NULL,0)) {
			retval = false;
		} else {
			mysql_close(&mysql);
		}

		if (w_hostname)	free(w_hostname);
		if (w_username)	free(w_username);
		if (w_password)	free(w_password);
		if (w_database)	free(w_database);
		if (hostname) free(hostname);
		if (username) free(username);
		if (password) free(password);
		if (database) free(database);
	}
	
	return retval;
	*/
}

MYSQLLOG_API BOOL ChangeUserPassword(LPTSTR string1, LPTSTR string2, LPTSTR string3) {
	return true;
}

MYSQLLOG_API LPCTSTR AboutPlugin(void) {
	return TEXT("MySQL Logging Plugin - Written by Nathan Yocom (nate@xpasystems.com), Sponsored by the University of Arizona");
}

MYSQLLOG_API void ChangePluginSettings(void) {
	DialogBox((HINSTANCE)gPluginHandle,MAKEINTRESOURCE(IDD_CONFIG),NULL,(DLGPROC)ConfigBoxProc);
}

MYSQLLOG_API void LoginHook(pGinaInfo *settingsInfo) {
	MYSQL mysql;
	unsigned int port = 3306;
	char *hostname,*username,*password,*database,*table;
	TCHAR *w_hostname,*w_username,*w_password,*w_database,*w_table;
	TCHAR errorString[4096];
	char queryString[4096];

	memset(errorString,0,4096);
	hostname=username=password=database=table=NULL;
	w_table=w_hostname=w_username=w_password=w_database=NULL;

	mysql_init(&mysql);

	w_hostname = regReadString(_T("Server"));
	w_username = regReadString(_T("Username"));
	w_password = regReadString(_T("Password"));
	w_database = regReadString(_T("Database"));
	w_table = regReadString(_T("Table"));
	port = regReadDword(_T("Port"));
	hostname = convert_to_char(w_hostname);
	username = convert_to_char(w_username);
	password = convert_to_char(w_password);
	database = convert_to_char(w_database);
	table = convert_to_char(w_table);

	if (mysql_real_connect(&mysql,hostname,username,password,database,port,NULL,0)) {
		sprintf(queryString,"update %s set logoutstamp=NOW() where logoutstamp=0 and machine=\"%s\" and ipaddress=\"%s\"",table,get_machinename(),get_ip());
		mysql_query(&mysql,queryString);
		sprintf(queryString,"insert into %s (loginstamp,username,machine,ipaddress) values (NOW(),\"%s\",\"%s\",\"%s\")",table,convert_to_char(settingsInfo->Username),get_machinename(),get_ip());
		mysql_query(&mysql,queryString);
		mysql_close(&mysql);
	} else {
		// We couldnt connect
		wsprintf(errorString,_T("LoginHook MySQL Error: %s"),convert_to_wchar(mysql_error(&mysql)));
		settingsInfo->errorString = _tcsdup(errorString);
	}

	if (w_hostname)	free(w_hostname);
	if (w_username)	free(w_username);
	if (w_password)	free(w_password);
	if (w_database)	free(w_database);
	if (w_table) free(w_table);
	if (hostname) free(hostname);
	if (username) free(username);
	if (password) free(password);
	if (database) free(database);
	if (table) free(table);
}

MYSQLLOG_API void LogoutHook(pGinaInfo *settingsInfo) {
	MYSQL mysql;
	unsigned int port = 3306;
	char *hostname,*username,*password,*database,*table;
	TCHAR *w_hostname,*w_username,*w_password,*w_database,*w_table;
	TCHAR errorString[4096];
	char queryString[4096];

	memset(errorString,0,4096);
	hostname=username=password=database=table=NULL;
	w_table=w_hostname=w_username=w_password=w_database=NULL;

	mysql_init(&mysql);

	w_hostname = regReadString(_T("Server"));
	w_username = regReadString(_T("Username"));
	w_password = regReadString(_T("Password"));
	w_database = regReadString(_T("Database"));
	w_table = regReadString(_T("Table"));
	port = regReadDword(_T("Port"));
	hostname = convert_to_char(w_hostname);
	username = convert_to_char(w_username);
	password = convert_to_char(w_password);
	database = convert_to_char(w_database);
	table = convert_to_char(w_table);

	if (mysql_real_connect(&mysql,hostname,username,password,database,port,NULL,0)) {
		sprintf(queryString,"update %s set logoutstamp=NOW() where logoutstamp=0 and username=\"%s\" and machine=\"%s\" and ipaddress=\"%s\"",table,convert_to_char(settingsInfo->Username),get_machinename(),get_ip());
		mysql_query(&mysql,queryString);
		mysql_close(&mysql);
	} else {
		// We couldnt connect
		wsprintf(errorString,_T("LoginHook MySQL Error: %s"),convert_to_wchar(mysql_error(&mysql)));
		settingsInfo->errorString = _tcsdup(errorString);
	}

	if (w_hostname)	free(w_hostname);
	if (w_username)	free(w_username);
	if (w_password)	free(w_password);
	if (w_database)	free(w_database);
	if (w_table) free(w_table);
	if (hostname) free(hostname);
	if (username) free(username);
	if (password) free(password);
	if (database) free(database);
	if (table) free(table);
}

MYSQLLOG_API BOOL IsRequired(void) {
	return regReadBool(_T("IsRequired"));
}


/**
 * Registry handling/settings functions
 */

TCHAR * regReadString(LPCTSTR location)
{
	LONG lResult;
	HKEY hKey;
	DWORD dwBytesRead = 2048;
	TCHAR result[2048];
	TCHAR *ret;

	lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\MySQLLogger"),0,KEY_QUERY_VALUE,&hKey);

	if (lResult == ERROR_SUCCESS) {
		lResult = RegQueryValueEx(hKey,location,NULL,NULL,(LPBYTE)&result,&dwBytesRead);

		if (lResult == ERROR_SUCCESS) {
			if (dwBytesRead > 0) {
				if (_tcscmp(result,L"") != 0) {	// If its just a space
					ret = _tcsdup(result);
					RegCloseKey(hKey);
					return ret;
				}
			}
		}
	}
	RegCloseKey(hKey);
	return NULL;
}

TCHAR * regReadStringDefault(LPCTSTR location, TCHAR * defaultVal)
{
	TCHAR *ret = regReadString(location);

	if ((NULL == ret) && (NULL != defaultVal)) {
		ret = _tcsdup(defaultVal);
	}
	return ret;
}

BOOL regWriteString(LPTSTR value,LPCTSTR location)
{
	HKEY hKey;

	if (RegCreateKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\MySQLLogger"),0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&hKey,NULL) == ERROR_SUCCESS) {
		if (value != NULL)
			if (RegSetValueEx(hKey,location,0,REG_SZ,(CONST BYTE *) value, (DWORD)(_tcslen(value)*sizeof(TCHAR))) == ERROR_SUCCESS) {
				RegFlushKey(hKey);
				RegCloseKey(hKey);
				return true;
			}
	}

	RegFlushKey(hKey);
	RegCloseKey(hKey);
	return false;
}

BOOL regWriteDword(DWORD value,LPCTSTR location)
{
	HKEY hKey;
	DWORD write;

	write = value;

	if (RegCreateKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\MySQLLogger"),0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,  &hKey,NULL) == ERROR_SUCCESS)
		if (RegSetValueEx(hKey,location,0,REG_DWORD,(LPBYTE)&write,sizeof(DWORD)) == ERROR_SUCCESS) {
			RegFlushKey(hKey);
			RegCloseKey(hKey);
			return true;
		}
	RegFlushKey(hKey);
	RegCloseKey(hKey);
	return false;
}

DWORD regReadDword(LPCTSTR location)
{
	LONG lResult;
	HKEY hKey;
	DWORD value = 0;
	DWORD size = sizeof(DWORD);

	lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\MySQLLogger"),0,KEY_QUERY_VALUE,&hKey);

	if (lResult == ERROR_SUCCESS) {
		lResult = RegQueryValueEx(hKey,location,NULL,NULL,(LPBYTE)&value,&size);

		if (lResult == ERROR_SUCCESS) {
			RegCloseKey(hKey);
			return value;
		}
	}
	RegCloseKey(hKey);
	return 0;
}


void regDelValue(LPCTSTR location)
{
	HKEY    hKey;
	LONG    lResult;

	lResult = RegOpenKeyEx( HKEY_LOCAL_MACHINE,
							_T("SOFTWARE\\pGina\\MySQLLogger"),
							0, KEY_WRITE, &hKey);

	if (lResult == ERROR_SUCCESS) {
		lResult = RegDeleteValue(hKey,location);
		RegFlushKey(hKey);
	}

	RegCloseKey(hKey);
}

BOOL regReadBool(LPCWSTR location)
{
	LONG lResult;
	HKEY hKey;
	DWORD value = 0;
	DWORD size = sizeof(DWORD);

	lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE,L"SOFTWARE\\pGina\\MySQLLogger",0,KEY_QUERY_VALUE,&hKey);

	if (lResult == ERROR_SUCCESS) {
		lResult = RegQueryValueEx(hKey,location,NULL,NULL,(LPBYTE)&value,&size);

		if (lResult == ERROR_SUCCESS) {
			RegCloseKey(hKey);
			if (value == 1)
				return true;
			else
				return false;
		}
	}
	RegCloseKey(hKey);
	return false;
}

BOOL regWriteBool(BOOL value,LPCTSTR location)
{
	HKEY hKey;
	DWORD write;

	write = value ? 1 : 0;

	if (RegCreateKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\MySQLLogger"),0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,  &hKey,NULL) == ERROR_SUCCESS)
		if (RegSetValueEx(hKey,location,0,REG_DWORD,(LPBYTE)&write,sizeof(DWORD)) == ERROR_SUCCESS) {
			RegFlushKey(hKey);
			RegCloseKey(hKey);
			return true;
		}
	RegFlushKey(hKey);
	RegCloseKey(hKey);
	return false;
}

/**
 * Configuration Dialog Callback Function
 */
BOOL CALLBACK ConfigBoxProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{
	TCHAR Buffer[2048];
	switch (message) {
	case WM_INITDIALOG:
		CenterWindow(hwndDlg);

		// Load all our settings and place in the dialog
		SetDlgItemText(hwndDlg,IDC_SERVER,regReadStringDefault(_T("Server"),_T("mysql.server.here")));
		wsprintf(Buffer,_T("%d"),regReadDword(_T("Port")) != 0 ? regReadDword(_T("Port")) : 3306);
		SetDlgItemText(hwndDlg,IDC_PORT,Buffer);
		SetFocus(GetDlgItem(hwndDlg,IDC_SERVER));
		SetDlgItemText(hwndDlg,IDC_USERNAME,regReadStringDefault(_T("Username"),_T("mysql_username")));
		SetDlgItemText(hwndDlg,IDC_PASSWORD,regReadStringDefault(_T("Password"),_T("mysql_password")));
		SetDlgItemText(hwndDlg,IDC_DATABASE,regReadStringDefault(_T("Database"),_T("mysql_database")));
		SetDlgItemText(hwndDlg,IDC_TABLE,regReadStringDefault(_T("Table"),_T("mysql_table")));

		SendMessage(GetDlgItem(hwndDlg,IDC_CHECKCONNECTION),BM_SETCHECK,regReadBool(_T("CheckConnection")),0);
		SendMessage(GetDlgItem(hwndDlg,IDC_ISREQUIRED),BM_SETCHECK,regReadBool(_T("IsRequired")),0);

		return TRUE;
	case WM_COMMAND: 
		switch (LOWORD(wParam)) {
		case IDOK:
			// Save all our settings to the registry
			GetDlgItemText(hwndDlg,IDC_SERVER,Buffer,2048);
			regWriteString(Buffer,_T("Server"));
			GetDlgItemText(hwndDlg,IDC_PORT,Buffer,2048);
			regWriteDword(_wtoi(Buffer),_T("Port"));
			GetDlgItemText(hwndDlg,IDC_USERNAME,Buffer,2048);
			regWriteString(Buffer,_T("Username"));
			GetDlgItemText(hwndDlg,IDC_PASSWORD,Buffer,2048);
			regWriteString(Buffer,_T("Password"));
			GetDlgItemText(hwndDlg,IDC_DATABASE,Buffer,2048);
			regWriteString(Buffer,_T("Database"));
			GetDlgItemText(hwndDlg,IDC_TABLE,Buffer,2048);
			regWriteString(Buffer,_T("Table"));

			regWriteBool(IsDlgButtonChecked(hwndDlg,IDC_CHECKCONNECTION),_T("CheckConnection"));
			regWriteBool(IsDlgButtonChecked(hwndDlg,IDC_ISREQUIRED),_T("IsRequired"));

			EndDialog(hwndDlg,IDOK);
			break;
		case IDCANCEL:
			EndDialog(hwndDlg, IDCANCEL);
			break;
		}
		return TRUE;
	} 
	return FALSE;
}

VOID CenterWindow(HWND hwnd)
{
	RECT    rect;
	LONG    dx, dy;
	LONG    dxParent, dyParent;
	LONG    Style;

	GetWindowRect(hwnd, &rect);

	dx = rect.right - rect.left;
	dy = rect.bottom - rect.top;

	Style = GetWindowLong(hwnd, GWL_STYLE);
	if ((Style & WS_CHILD) == 0) {
		dxParent = GetSystemMetrics(SM_CXSCREEN);
		dyParent = GetSystemMetrics(SM_CYSCREEN);
	} else {
		HWND    hwndParent;
		RECT    rectParent;

		hwndParent = GetParent(hwnd);
		if (hwndParent == NULL) {
			hwndParent = GetDesktopWindow();
		}

		GetWindowRect(hwndParent, &rectParent);

		dxParent = rectParent.right - rectParent.left;
		dyParent = rectParent.bottom - rectParent.top;
	}

	rect.left = (dxParent - dx) / 2;
	rect.top  = (dyParent - dy) / 3;

	SetWindowPos(hwnd, HWND_TOPMOST, rect.left, rect.top, 0, 0, SWP_NOSIZE);

	SetForegroundWindow(hwnd);
}

/**
 * Char handling
 */
char * convert_to_char(const TCHAR *from)
{
	char *to = (char *) malloc(_tcslen(from) * sizeof(TCHAR));

	WideCharToMultiByte(CP_ACP,
						NULL,
						(LPCWSTR)from,
						-1,
						to,
						_tcslen(from) * sizeof(TCHAR),
						NULL,
						NULL);

	return to;
}

TCHAR * convert_to_wchar(const char *from)
{
	TCHAR *to;
	if (from == NULL)
		return NULL;

	to = (TCHAR *) malloc(strlen(from)*sizeof(TCHAR));
	MultiByteToWideChar(CP_ACP,
						NULL,
						(LPCSTR)from,
						strlen(from),
						(LPWSTR)to,
						strlen(from)*sizeof(TCHAR));                    

	return to;
}

char *get_ip(void) {
	PIP_ADAPTER_INFO pAdapterInfo;
	PIP_ADAPTER_INFO pAdapter = NULL;
	DWORD dwRetVal = 0;

	pAdapterInfo = (IP_ADAPTER_INFO *) malloc( sizeof(IP_ADAPTER_INFO) );
	ULONG ulOutBufLen = sizeof(IP_ADAPTER_INFO);

	// Make an initial call to GetAdaptersInfo to get
	// the necessary size into the ulOutBufLen variable
	if (GetAdaptersInfo( pAdapterInfo, &ulOutBufLen) == ERROR_BUFFER_OVERFLOW) {
		free(pAdapterInfo);
		pAdapterInfo = (IP_ADAPTER_INFO *) malloc (ulOutBufLen); 
	}

	if ((dwRetVal = GetAdaptersInfo( pAdapterInfo, &ulOutBufLen)) == NO_ERROR) {
		pAdapter = pAdapterInfo;
		if(pAdapter) {
			return pAdapter->IpAddressList.IpAddress.String;
		}
	} else {
		return "Unknown";
	}
	return "Unknown";
}
char *get_machinename(void) {
	TCHAR  pszSystemName[2048];
	GetEnvironmentVariable( _T("COMPUTERNAME"), pszSystemName, 2048 );
	return convert_to_char(pszSystemName);
}

