// NISplugin.cpp : Defines the initialization routines for the DLL.
// 
// NIS Plugin created by Marco Rigotti April 10st, 2003
// This plugin will compare a username and password against
// a NIS database 

#include "stdafx.h"
#include "NISplugin.h"
#include "ConfigDialog.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include "fcntl.h"
#include "limits.h"
#include "AFXPRIV.H"
#include "io.h"
#include "ypclnt.h"
#include <rpc.h>

#include "types.h"
#include "bcopy.h"
#include "rpc.h"
#include "xdr.h"
#include "yp_prot.h"
#include "ypclnt.h"
#include "yp_prot.h"
#include "stdio.h"
#include "ctype.h"
#include "des.h"
#include <winreg.h>


#define BINDINGDIR "/var/yp/binding"

#ifdef _DEBUG
  #define new DEBUG_NEW
  #undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

FILE *file; /* declare a FILE pointer */

char *strg3, *strg4, *User, *Pass, *outbuf, *salt, *nisdom, *nismap, *errmsg;
int r, outbuflen;


char  *encrypted_password;
char *domainname, *inmap, *inkey;
TCHAR TempString[1024];


LONG mlResult;
HKEY mhKey;
TCHAR Nisdomain[2048];
DWORD dwnisdomain =2048, dwnismap =2048;
LPTSTR nisdomainname, nisdomainmap, errmsg2;

BOOL regWriteString(LPCTSTR value,LPCTSTR location)
{
    HKEY hKey;
    
    if(RegCreateKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Winlogon\\GinaLogon"),0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&hKey,NULL) == ERROR_SUCCESS)
    {
        if(value != NULL)
            if(RegSetValueEx(hKey,location,0,REG_SZ,(CONST BYTE *) value, _tcslen(value)*sizeof(TCHAR)) == ERROR_SUCCESS)
            {
                RegFlushKey(hKey);
                RegCloseKey(hKey);
                return true;
            }
    }
    
    RegFlushKey(hKey);
    RegCloseKey(hKey);
    return false;
}

TCHAR * regReadString(LPCTSTR location)
{
    LONG lResult;
	HKEY hKey;
    DWORD dwBytesRead = 2048;
    TCHAR result[2048];
    TCHAR *ret;

    lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Winlogon\\GinaLogon"),0,KEY_QUERY_VALUE,&hKey);
    
    if(lResult == ERROR_SUCCESS)
    {
    	lResult = RegQueryValueEx(hKey,location,NULL,NULL,(LPBYTE)&result,&dwBytesRead);
        
        if(lResult == ERROR_SUCCESS)
        {
            if(dwBytesRead > 0)
            {
				if(!_tcscmp(result,TEXT(""))) // If its just a space
				{
				    return NULL;                                                                                 
				}
				else
				{
					ret = (TCHAR *)malloc((sizeof(TCHAR) * dwBytesRead) + 1);
					ret = _tcsdup(result);
					RegCloseKey(hKey);
					return ret;
				}
            }
            else
            {
                return NULL;
            }
		}
    }
    RegCloseKey(hKey);
    return NULL;
} 


NISplugin_API BOOL UserLogin(LPTSTR Username, LPTSTR Password, pGinaInfo *settingsInfo)
{

  /* we need to initialize the windows sockets */
  rpc_nt_init();
  atexit((void(cdecl *)(void))rpc_nt_exit);


// Convert UNICODE to ASCII to compare against NIS database, since
// The NIS database does not contain UNICODE characters.
  USES_CONVERSION;
  User = T2A( Username );
  Pass = T2A( Password );

  domainname = "csglobal";
  inkey = User;
  inmap = "passwd.byname";

  mlResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Winlogon\\GinaLogon"),0,KEY_QUERY_VALUE,&mhKey);

  if(mlResult == ERROR_SUCCESS)
  {
    /* First we try to get the NIS domain name */
    mlResult = RegQueryValueEx(mhKey,_T("Default NIS Domain"),
                               NULL,
                               NULL,
                               (LPBYTE) Nisdomain,
                               &dwnisdomain);

    if(mlResult == ERROR_SUCCESS)
    {
      nisdomainname = _tcsdup(Nisdomain);
      nisdom = T2A(nisdomainname);
    }
    else
    {
      settingsInfo->errorString = _tcsdup(TEXT("Error reading registry entry."));
      return false;
    }

    /* Now we try to get the NIS map name that contains the passwd fields*/

    mlResult = RegQueryValueEx(mhKey,_T("NIS Password Map"),
                               NULL,
                               NULL,
                               (LPBYTE) Nisdomain,
                               &dwnismap);

    if(mlResult == ERROR_SUCCESS)
    {
      nisdomainmap = _tcsdup(Nisdomain);
      nismap = T2A(nisdomainmap);
    }
    else
    {
      settingsInfo->errorString = _tcsdup(TEXT("Error reading registry entry."));
      return false;
    }

  }
  else
  {
    settingsInfo->errorString = _tcsdup(TEXT("Error reading registry entry."));
    return false;
  }

  RegCloseKey(mhKey);



  strg3 = (char *) malloc(1000*sizeof(char)); 
  strg4 = (char *) malloc(1000*sizeof(char));
  salt = (char *) malloc(1000*sizeof(char));
  errmsg = (char *) malloc(1000*sizeof(char));

  /* use ypmatch to get the encrpyted passwd string */
  r = yp_match(domainname, inmap,
               inkey, strlen(inkey),
               &outbuf, &outbuflen);

  switch(r)
  {
  case 0:
    break;
  case YPERR_YPBIND:
    settingsInfo->errorString = _tcsdup(TEXT("yp_match error: not running ypbind"));
    return false;
  case 5:
    settingsInfo->errorString = _tcsdup(TEXT("Login Failed"));
    return false;
  default:
    sprintf(errmsg, "Login Failed. Reason: %s\n", yperr_string(r));
    errmsg2 = A2T(errmsg);
    settingsInfo->errorString = _tcsdup(errmsg2);
    return false;
  } 

  strg4 = strdup(outbuf);
  strg3 = strtok(strg4,":");
  strg3 = strtok(NULL,":");

  strncpy(salt,strg3,2);
  salt[2]=0;

  encrypted_password = crypt(Pass,salt);

  /* now we check if the user supplied passwd matches the encrypted one */

  if(strcmp(strg3,encrypted_password)==0)
  {
    settingsInfo->isAdmin = false;
    settingsInfo->userDescription = _tcsdup(TEXT("NISplugin Generated User"));
    settingsInfo->userGroups = _tcsdup(TEXT("USERS"));
    return true;
  }
  else
  {
    settingsInfo->errorString = _tcsdup(TEXT("Login Failed"));
    return false;
  }
}

NISplugin_API BOOL ChangeUserPassword(LPTSTR Username,LPTSTR OldPassword,LPTSTR NewPassword)
{
  return false;
}

NISplugin_API LPCTSTR AboutPlugin(void)
{
  return TEXT("This is the NISplugin, written by Marco Rigotti");
}

NISplugin_API void ChangePluginSettings(void)
{
  AFX_MANAGE_STATE(AfxGetStaticModuleState());
  CConfigDialog *myDialog = new CConfigDialog();
  myDialog->DoModal();
}

NISplugin_API void LoginHook(pGinaInfo *settingsInfo)
{
}

NISplugin_API void LogoutHook(pGinaInfo *settingsInfo)
{
}

NISplugin_API BOOL IsRequired(void)
{
  return false;
}


/////////////////////////////////////////////////////////////////////////////
// CNISpluginApp

BEGIN_MESSAGE_MAP(CNISpluginApp, CWinApp)
//{{AFX_MSG_MAP(CNISpluginApp)
// NOTE - the ClassWizard will add and remove mapping macros here.
//    DO NOT EDIT what you see in these blocks of generated code!
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNISpluginApp construction

CNISpluginApp::CNISpluginApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CNISpluginApp object

CNISpluginApp theApp;
