// NISplugin.cpp : Defines the initialization routines for the DLL.
// 
// NIS Plugin created by Marco Rigotti April 10st, 2003
// This plugin will compare a username and password against
// a NIS database 

#include "stdafx.h"
#include "NISplugin.h"
#include "ConfigDialog.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include "fcntl.h"
#include "limits.h"
#include "AFXPRIV.H"
#include "io.h"
#include "ypclnt.h"
#include <rpc.h>

#include "types.h"
#include "bcopy.h"
#include "rpc.h"
#include "xdr.h"
#include "yp_prot.h"
#include "ypclnt.h"
#include "yp_prot.h"
#include "stdio.h"
#include "ctype.h"
#include "des.h"
#include <winreg.h>


#define BINDINGDIR "/var/yp/binding"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

FILE *file; /* declare a FILE pointer */

char *strg3, *strg4, *User, *Pass, *outbuf, *salt, *nisdom, *nismap, *errmsg;
int r, outbuflen;


char  *encrypted_password;
char *domainname, *inmap, *inkey;
TCHAR TempString[1024];


LONG mlResult;
HKEY mhKey;
TCHAR Nisdomain[2048];
DWORD dwnisdomain =2048, dwnismap =2048;
LPTSTR nisdomainname, nisdomainmap, errmsg2;


NISplugin_API BOOL UserLogin(LPTSTR Username, LPTSTR Password, pGinaInfo *settingsInfo) {

/* we need to initialize the windows sockets */
  rpc_nt_init();
  atexit((void(cdecl *)(void))rpc_nt_exit);


// Convert UNICODE to ASCII to compare against NIS database, since
// The NIS database does not contain UNICODE characters.
USES_CONVERSION;
User = T2A( Username );
Pass = T2A( Password );

domainname = "csglobal";
inkey = User;
inmap = "passwd.byname";

// try to read domain name from registry

//file=fopen("c:\\tmp\\regtest.txt","w");

//fprintf(file,"We start\n\n"); 

mlResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina"),0,KEY_QUERY_VALUE,&mhKey);

        if(mlResult == ERROR_SUCCESS) {
//		fprintf (file,"Inside Software\\Pgina \n\n");

		/* First we try to get the NIS domain name */

		mlResult = RegQueryValueEx(mhKey,_T("nisdomain"),
								  NULL,
								  NULL,
								  (LPBYTE) Nisdomain,
								  &dwnisdomain);

			if(mlResult == ERROR_SUCCESS) {
//				fprintf (file,"getting the value of dwnisdomain = %d\n\n",dwnisdomain);
				nisdomainname = _tcsdup(Nisdomain);
				nisdom = T2A(nisdomainname);
//				fprintf (file,"the value of nisdomain = %s\n\n",nisdom);
			} else {
//				fprintf (file,"Can't get the value of nisdomain \n\n");
				settingsInfo->errorString = _tcsdup(TEXT("Error reading registry entry."));
//				fclose(file);
				return false;
			}

		/* Now we try to get the NIS map name that contains the passwd fields*/

			mlResult = RegQueryValueEx(mhKey,_T("nismap"),
								  NULL,
								  NULL,
								  (LPBYTE) Nisdomain,
								  &dwnismap);

			if(mlResult == ERROR_SUCCESS) {
//				fprintf (file,"getting the value of dwnisdomain = %d\n\n",dwnismap);
				nisdomainmap = _tcsdup(Nisdomain);
				nismap = T2A(nisdomainmap);
//				fprintf (file,"the value of nismap = %s\n\n",nismap);
			} else {
//				fprintf (file,"Can't get the value of nismap \n\n");
				settingsInfo->errorString = _tcsdup(TEXT("Error reading registry entry."));
//				fclose(file);
				return false;
			}

        } else {
//          fprintf (file, "Error reading registry entry for pgina.\n\n");
			settingsInfo->errorString = _tcsdup(TEXT("Error reading registry entry."));
//			fclose(file);
			return false;
		}

RegCloseKey(mhKey);



	strg3 = (char *) malloc(1000*sizeof(char));	
	strg4 = (char *) malloc(1000*sizeof(char));
	salt = (char *) malloc(1000*sizeof(char));
	errmsg = (char *) malloc(1000*sizeof(char));
/* use ypmatch to get the encrpyted passwd string */

    r = yp_match(domainname, inmap,
                   inkey, strlen(inkey),
                   &outbuf, &outbuflen);

switch(r)
       {
       case 0:
         break;
	   case YPERR_YPBIND:
//         fprintf(file, "yp_match: not running ypbind\n");
		 settingsInfo->errorString = _tcsdup(TEXT("yp_match error: not running ypbind"));
//		 fclose(file);
         return false;
	   case 5:
//		 fprintf(file, "User name NOT found");
		 settingsInfo->errorString = _tcsdup(TEXT("Login Failed"));
//		 fclose(file);
         return false;
	   default:
//         fprintf(file, "Login Failed. Reason: %s\n", yperr_string(r));
		 sprintf(errmsg, "Login Failed. Reason: %s\n", yperr_string(r));
		 errmsg2 = A2T(errmsg);
		 settingsInfo->errorString = _tcsdup(errmsg2);
//		 fclose(file);
         return false;
       } 

//fclose(file);

strg4 = strdup(outbuf);

//file=fopen("c:\\tmp\\output.txt","w");
//	fprintf (file,"The value of Username is %s\n\n",User);
//	fprintf (file,"The value of Password is %s\n\n",Pass);
//	fprintf(file,"outbuf = %s\n\n",outbuf);
//	fprintf(file,"domainname = %s\n\n",domainname);
//	fprintf(file,"inmap = %s\n\n",inmap);
//	fprintf(file,"inkey = %s\n\n",inkey);
//	fprintf(file,"outbuflen = %d\n\n",outbuflen);
//	fprintf(file,"r equals = %d\n\n",r);



	strg3 = strtok(strg4,":");
	strg3 = strtok(NULL,":");

//	fprintf(file,"strg3 = %s\n\n",strg3);
//	fprintf(file,"strg4 = %s\n\n",strg4);


/* usage crypt(passwd,salt) */
/* here the salt is salt and passwd is Pass */

strncpy(salt,strg3,2);
salt[2]=0;

//fprintf(file,"Salt = %s\n\n",salt);

 /*   encrypted_password = crypt(&password_provided_by_user,some_salt); */
    encrypted_password = crypt(Pass,salt);


//fprintf(file,"Pass = %s\n\n",Pass);
//fprintf(file,"encrypted_password = %s\n\n",encrypted_password);

/* now we check if the user supplied passwd matches the encrypted one */

if( strcmp(strg3,encrypted_password)==0) {


//	fprintf (file,"We have a match let the user in!");
//	fclose(file);
		settingsInfo->isAdmin = false;
		settingsInfo->userDescription = _tcsdup(TEXT("NISplugin Generated User"));
		settingsInfo->userGroups = _tcsdup(TEXT("USERS"));
		return true;

} else {
//	fprintf (file,"We do NOT have a match!");
//	fclose(file);
	settingsInfo->errorString = _tcsdup(TEXT("Login Failed"));
	return false;

}
	

}

NISplugin_API BOOL ChangeUserPassword(LPTSTR Username,LPTSTR OldPassword,LPTSTR NewPassword) {
	return false;
}

NISplugin_API LPCTSTR AboutPlugin(void)
{
	return TEXT("This is the NISplugin, written by Marco Rigotti");
}

NISplugin_API void ChangePluginSettings(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	CConfigDialog *myDialog = new CConfigDialog();
	myDialog->DoModal();
}

NISplugin_API void LoginHook(pGinaInfo *settingsInfo)
{
}

NISplugin_API void LogoutHook(pGinaInfo *settingsInfo)
{
}

NISplugin_API BOOL IsRequired(void)
{
		return false;
}


/////////////////////////////////////////////////////////////////////////////
// CNISpluginApp

BEGIN_MESSAGE_MAP(CNISpluginApp, CWinApp)
	//{{AFX_MSG_MAP(CNISpluginApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNISpluginApp construction

CNISpluginApp::CNISpluginApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CNISpluginApp object

CNISpluginApp theApp;
