/*
 * Copyright (c) 1997 Nigel Williams <williams@yp.deakin.edu.au>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote
 *    products derived from this software without specific prior written
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: protos.h,v 1.7 1997/06/09 10:24:07 williams Exp $	
 *
 */


#ifndef PROTOS_H
#define PROTOS_H

extern char *crypt(char *key, char *salt);
extern int rpc_nt_init(void);
extern int rpc_nt_exit(void);

int
CALLBACK
LogonDlgProc(
    HWND        hDlg,
    UINT        Message,
    WPARAM      wParam,
    LPARAM      lParam);


int
CALLBACK
ShutdownDlgProc(
    HWND        hDlg,
    UINT        Message,
    WPARAM      wParam,
    LPARAM      lParam);

int
CALLBACK
OptionsDlgProc(
    HWND        hDlg,
    UINT        Message,
    WPARAM      wParam,
    LPARAM      lParam);

int
CALLBACK
ChangePasswordDlgProc(
    HWND        hDlg,
    UINT        Message,
    WPARAM      wParam,
    LPARAM      lParam);

int
CALLBACK
LockedDlgProc(
    HWND        hDlg,
    UINT        Message,
    WPARAM      wParam,
    LPARAM      lParam);

int
CALLBACK
CheckBeforeUnlockDlgProc(
	HWND    hDlg,
	UINT    Message,
	WPARAM  wParam,
	LPARAM  lParam);

//Added by Dave 11/8/2000
int
CALLBACK
DisplayMesgDlgProc(
	HWND hDlg,
	UINT Message,
	WPARAM wParam,
	LPARAM lParam);

VOID
CenterWindow(
    HWND    hwnd
    );

int
ErrorMessage(
    HWND         hWnd,
	PGinaContext pGinaContext,
    PWSTR        pszTitleBar,
    DWORD        Buttons);

BOOL
GetUserProfilePath(
    IN LPWSTR UserName,     
    IN LPWSTR Domain,       
    OUT LPWSTR *ProfilePath 
    );

int
AttemptLogon(
    PHANDLE         phUser,
    PMiniAccount    pAccount,
    PSID            pLogonSid,
    PLUID           pLogonId,
	PBOOL           pAdministrators
	);

PWSTR
AllocAndCaptureText(
    HWND    hDlg,
    int     Id);

PWSTR
DupString(
    PWSTR   pszText);

BOOL
CheckForNetApi(void);

char *GetNisPasswdEnt(PWSTR pszUsername);

void SetPasswdData(const char *pwdEnt,PMiniAccount pAccount);

BOOL CheckNisPassword(const char *pwdEnt, PWSTR pszPassword);

BOOL HasUserGotAnAccount(PWSTR pszUsername);

BOOL CreateInitialAccountForUser(PMiniAccount pAccount);

BOOL SetUserVariables(PMiniAccount pAccount);

WCHAR *ErrorMessageText(VOID);

LPWSTR GetTextValueFromRegistryHive(LPWSTR valueName);

DWORD GetBinaryValueFromRegistryHive(LPWSTR valueName);

BOOL RemoteHomeDir(void);

PWSTR GetLoggedOnUserName(PHANDLE pCurrentUserToken);

char *YpMatch(const char *inkey,const char *inmap);

BOOL YpEnum(const char *inMap, int (*func)(int,char *,int,char *,int, char *), void *data);

BOOL NoYpEnum(const char *inMap, int (*func)(int,char *,int,char *,int, char *), void *data);

int YpPrintIt(int instatus,char *inkey, int inkeylen,char *inval, int invallen,char *indata);

int YpEnumStore(int inStatus,char *inkey, int inkeylen,char *inval, int invallen,char *indata);

YPENUMBUF *YpEnumBufInitialise(void);

char *NarrowStringFromWide(const WCHAR *w);

char *DupNarrow(const char *);

char *RemoveMultipleCharacters(const char *s,const char *c);

char *RemoveMultipleBlanks(const char *s);

char *StripLeadingAndTrailingCharacters(const char *s,const char *c);

char *StripLeadingAndTrailingBlanks(const char *s);

WCHAR *WideStringFromNarrow(const char *n);

char *NarrowStringFromWide(const WCHAR *w);

void InitializeVersionInformation(void);

char *GetNthField(const char *,char sep,int n);

BOOL ConnectHomeDirectory(PMiniAccount pMini);

PWSTR GetLoggedOnUserName(PHANDLE pCurrentUserToken);

int CheckLogonData(PMiniAccount pAccount);

int CheckBeforeUnlock(PHANDLE pCurrentUserToken,PMiniAccount pMini);

PWSTR GetTime(void);

DWORD DealWithDialogTimeouts(DWORD result);

BOOL TryToChangePassword(HWND hDlg,PGinaContext pGinaContext);

int ShutdownDialogInit(HWND hDlg,LPARAM lParam);

VOID UpdateShutdownSettings(PMiniAccount pMini,DWORD Setting);

int Logon(
	  PVOID                   pWlxContext,
	  DWORD                   dwSasType,
	  PLUID                   pAuthenticationId,
	  PSID                    pLogonSid,
	  PDWORD                  pdwOptions,
	  PHANDLE                 phToken,
	  PWLX_MPR_NOTIFY_INFO    pMprNotifyInfo,
	  PVOID *                 pProfile);

PWSTR GetTextValueFromLocalMachine(LPWSTR key, LPWSTR valueName);

DWORD StartAsUser(PGinaContext pGinaContext,PWSTR pszCommand,PWSTR pszDesktopName,PVOID pEnvironment);

PWSTR GetHomeDirectoryServer(PWSTR pszUsername);

LPWSTR GetHomeDirDrive(void);

LPWSTR GetRequiredGroups(LPWSTR pszUsername);

BOOL GetTextualSid(PSID pSid,LPTSTR TextualSid,LPDWORD dwBufferLen);

// Added by Dave 30/8/2000
PSID GetSidFromUserToken(HANDLE hToken);


PWSTR GetTextualSidFromUserToken(HANDLE hToken);

PWCHAR UpdateUsersNTEnvironment(PMiniAccount pMini, PWCHAR pEnvironment);

int YpChangePassword(char *username, char *oldPassword, char *newPassword, BOOL passwdAdmin);

char *strsep(char **pp,const char *delim);

void GetLogonSid(PHANDLE phUserToken, PSID pLogonSid);

BOOL IsUserInGroup(PHANDLE phUserToken, PWSTR pszGroup);

void RegEnvDelete(ENVIRONMENT *env);

ENVIRONMENT *GetUserEnvironment(PMiniAccount pMini);

ENVIRONMENT *UpdateStandardMachineEnvironment(void);

BOOL UpdateEncryptedSambaServers(PMiniAccount pMini);


//Added Dave 30/8/2000
BOOL fixRoamingProfileSecurity(PMiniAccount pMini);

BOOL ConfigureRegistry(char *level,ENVIRONMENT *environment);

BOOL LockLiloMap(void);
BOOL RebootTo(PSTR commandLine);


BOOL SetHomeDir(void);
BOOL SetProfile(void);
BOOL SetGroups(void);
BOOL SetExactGroups(void);
BOOL ConfigureUser(void);
BOOL ConfigureMachine(void);
BOOL ChangeNisPassword(void);
BOOL UseSambapasswdd(void);
BOOL UseLilo(void);
BOOL StartDebugLog(void);

BOOL SetSoleServer(void);
BOOL SetServerFromHomes(void);

PWSTR GetRebootValueFromRegistryHive(PWSTR rebootSelection);


#endif
