/*
pGina PAM Plugin for pGina
Copyright (C) 2003 Nathan Yocom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Email: nate.yocom@xpasystems.com
Web: http://pgina.xpasystems.com
Snail Mail:
  Nathan Yocom 
  9 Evergreen Farms Rd.
  Scarborough, ME 04074
  Phone: 207-450-4948
*/
// PAMPluginConfig.cpp : implementation file
//

#include "stdafx.h"
#include "PAMPlugin.h"
#include "PAMPluginConfig.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// PAMPluginConfig dialog


PAMPluginConfig::PAMPluginConfig(CWnd* pParent /*=NULL*/)
	: CDialog(PAMPluginConfig::IDD, pParent)
{
	//{{AFX_DATA_INIT(PAMPluginConfig)
	m_AboutString = _T("");
	m_admin_group = _T("");
	m_check_admin = FALSE;
	m_hostname = _T("");
	m_port = _T("");
	m_reflect_group = FALSE;
	m_pass_change = FALSE;
	m_required = FALSE;
	//}}AFX_DATA_INIT
}


void PAMPluginConfig::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(PAMPluginConfig)
	DDX_Text(pDX, IDC_ABOUT, m_AboutString);
	DDX_Text(pDX, IDC_ADMINGROUP, m_admin_group);
	DDX_Check(pDX, IDC_CREATEADMINS, m_check_admin);
	DDX_Text(pDX, IDC_HOSTNAME, m_hostname);
	DDX_Text(pDX, IDC_PORT, m_port);
	DDX_Check(pDX, IDC_REFLECTGROUP, m_reflect_group);
	DDX_Check(pDX, IDC_PASSCHANGE, m_pass_change);
	DDX_Check(pDX, IDC_REQUIRED, m_required);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(PAMPluginConfig, CDialog)
	//{{AFX_MSG_MAP(PAMPluginConfig)
	ON_BN_CLICKED(IDOK, OnSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// PAMPluginConfig message handlers

int PAMPluginConfig::DoModal() 
{
	// TODO: Add your specialized code here and/or call the base class
	m_AboutString = PAMPLUGIN_ABOUT;
	CString host_from_reg = regReadString("PAMHost");
	if(host_from_reg.GetLength() != 0)
	{
		m_hostname = host_from_reg.Left(host_from_reg.Find(":"));
		m_port = host_from_reg.Right(host_from_reg.GetLength() - host_from_reg.Find(":") - 1);
	}
	else
	{
		m_hostname = "Your pGina PAM host here";
		m_port = "299";
	}
	m_reflect_group = regReadBool("reflect_group");
	m_check_admin = regReadBool("create_admins");
	m_admin_group = regReadString("admin_group");
	m_pass_change = regReadBool("change_pass");
	m_required = regReadBool("am_i_required");

	return CDialog::DoModal();
}

void PAMPluginConfig::GoGo()
{
	DoModal();
}

void PAMPluginConfig::OnSave() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_port.GetLength() == 0)
		m_port = "299";

	CString combo_hostname = m_hostname + ":" + m_port;
	
	regWriteBool(m_check_admin,"create_admins");
	regWriteBool(m_reflect_group,"reflect_group");
	regWriteBool(m_pass_change,"change_pass");
	regWriteBool(m_required,"am_i_required");
	regWriteString(combo_hostname,"PAMHost");
	regWriteString(m_admin_group,"admin_group");

	
	MessageBox("Settings Saved","Saved",MB_OK);

	CDialog::OnOK();
}
