/*
pGina POPAuth Plugin
Copyright 2003, Joseph Robinson


This program is free software; you can redistribute it and/or 
modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.


This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.


You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
02111-1307, USA.


Email: nate.yocom@xpasystems.com
Web: http://pgina.xpasystems.com
Snail Mail:
  Nathan Yocom
  9 Evergreen Farms Rd.
  Scarborough, ME 04074
  Phone: 207-450-4948
*/
// SamplePlugin.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "SamplePlugin.h"
#include "ConfigDialog.h"
#include "winsock.h"
#include "string"

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

LPTSTR convert_to_wchar(const char *from)
{
	TCHAR *to;
	if(from == NULL)
		return NULL;
	
	to = (TCHAR *) malloc(strlen(from)*sizeof(TCHAR));
	MultiByteToWideChar(CP_ACP,
						NULL,
						(LPCSTR)from,
						strlen(from),
						(LPWSTR)to,
						strlen(from)*sizeof(TCHAR));					

	return to;
}

BOOL regWriteString(LPTSTR value,LPCTSTR location)
{
    HKEY hKey;
    
    if(RegCreateKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\POPAuth"),0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&hKey,NULL) == ERROR_SUCCESS)
    {
        if(value != NULL)
            if(RegSetValueEx(hKey,location,0,REG_SZ,(CONST BYTE *) value, _tcslen(value)*sizeof(TCHAR)) == ERROR_SUCCESS)
            {
                RegFlushKey(hKey);
                RegCloseKey(hKey);
                return true;
            }
    }
    
    RegFlushKey(hKey);
    RegCloseKey(hKey);
    return false;
}

TCHAR * regReadString(LPCTSTR location)
{
    LONG lResult;
	HKEY hKey;
    DWORD dwBytesRead = 2048;
    TCHAR result[2048];
    TCHAR *ret;

    lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\POPAuth"),0,KEY_QUERY_VALUE,&hKey);
    
    if(lResult == ERROR_SUCCESS)
    {
    	lResult = RegQueryValueEx(hKey,location,NULL,NULL,(LPBYTE)&result,&dwBytesRead);
        
        if(lResult == ERROR_SUCCESS)
        {
            if(dwBytesRead > 0)
            {
				if(!_tcscmp(result,TEXT(""))) // If its just a space
				{
				    return NULL;                                                                                 
				}
				else
				{
					ret = (TCHAR *)malloc((sizeof(TCHAR) * dwBytesRead) + 1);
					ret = _tcsdup(result);
					RegCloseKey(hKey);
					return ret;
				}
            }
            else
            {
                return NULL;
            }
        }
    }
    RegCloseKey(hKey);
    return NULL;
}

DWORD regReadDWORD(LPCTSTR location)
{
	LONG lResult;
	HKEY hKey;
	DWORD value = 0;
	DWORD size = sizeof(DWORD);

	lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\POPAuth"),0,KEY_QUERY_VALUE,&hKey);

	if(lResult == ERROR_SUCCESS)
	{
		lResult = RegQueryValueEx(hKey,location,NULL,NULL,(LPBYTE)&value,&size);

		if(lResult == ERROR_SUCCESS)
		{
			RegCloseKey(hKey);
			return value;
		}
	}
	RegCloseKey(hKey);
	return 0;
}


char * convert_to_char(const TCHAR *from)
{
	char *to = (char *) GlobalAlloc(NULL,1024);
	
	WideCharToMultiByte(CP_ACP,
						NULL,
						(LPCWSTR)from,
						-1,
						to,
						1024,
						NULL,
						NULL);
	
	return to;
}

char * read_from_socket(SOCKET s)
{
	char buffer[8192];
	char *ret;
	char this_one;
	int error = 0, read_in = 0;

	memset(buffer,'\0',sizeof(buffer));

	for(read_in = 0; read_in < sizeof(buffer); read_in += error)
	{
		error = recv(s,&this_one,1,0);
		buffer[read_in] = this_one;

		if(error <= 0 || this_one == '\0' || this_one == '\n')
			break;
	}

	if(error <= 0)
		buffer[read_in] = '\0'; // NULL term manually if we get an error
	
	// Buffer is good here
	ret = new(char[strlen(buffer)+1]);
//	ret = (char *) malloc(strlen(buffer) + 1);
	strcpy(ret,buffer);

	return ret;
}

bool testUserLogin(char *username, char *password, char *host,pGinaInfo *settingsInfo) {
	SOCKET s;
	WSADATA wsaData;
	sockaddr_in addr;

	char greeting[1024];
	char rcv[1024];
	string POPcommand;				//variable for the POP specific command to use
	string userSTR = username;
	string passSTR = password;		//variable for POP password to send
	string CRLFstr = "\r\n";		//carraige return, line feed must terminate POP commands
	string commandMsg;				//string with whole POP command message to send
	char * mBuf = NULL;
	bool isAuthenticated = false;
	char *hostAddress;
	string shostAddress = host;
	struct hostent *Host = NULL;

	// Don't even try pop for administrator - avoids some sneaky sniffing attack
	if(userSTR == "Administrator" || userSTR == "administrator")
		return false;
	
	int wsaret=WSAStartup(0x101,&wsaData);
    //WSAStartup returns zero on success.
    //If it fails we set error string and return false for no login
    if(wsaret!=0)
	{		
		settingsInfo->errorString = _tcsdup(TEXT("Wrong version of Winsock"));
		return false;
	}

	// Do the resolv
	//shostAddress = convert_to_char(regReadString(TEXT("host")));
	hostAddress = (char *)malloc(shostAddress.length() + 2);
	strcpy(hostAddress,shostAddress.c_str());
	Host = gethostbyname(hostAddress);

	// Kickout if the resolv failed
	if(Host == NULL)
	{
		settingsInfo->errorString = _tcsdup(TEXT("Error resolving hostname"));
		WSACleanup();
		return false;
	}

    //Now we populate the sockaddr_in structure
    addr.sin_family=AF_INET; //Address family
	memcpy(&(addr.sin_addr.s_addr), Host->h_addr, Host->h_length);	//IP address
    //addr.sin_addr.s_addr=inet_addr("127.0.0.1"); //IP address of POP server
    addr.sin_port=htons((u_short)110); //port to use, POP = 110

    //the socket function creates our SOCKET
    s=socket(AF_INET,SOCK_STREAM,0);
	
	//If the socket() function fails we set error string and return false for no login
    if(s==INVALID_SOCKET)
	{	
		settingsInfo->errorString = _tcsdup(TEXT("Invalid Socket"));
		return false;
	}

	// From timeout patch thanks to Melvin Lasky and Randy Dixon,
	//   modified by Nate Yocom to read timeout value from registry
	//   and default to infinite (previous behavior)
	int timeout = 0;	// 0 == infinite
	timeout = regReadDWORD(TEXT("timeout"));
	timeout = timeout * 1000;	// value in registry is stored as number of seconds

	// Don't set a timeout if its 0 (infinite)
	if(timeout) {
		int timeout_opt_err = setsockopt(s, SOL_SOCKET, SO_RCVTIMEO, (char *) &timeout, sizeof(timeout));
	}
 
	//connect links the socket we just created with the sockaddr_in 
    //structure. Basically it connects the socket with 
    //the local address and a specified port.
    //If it returns non-zero quit, as this indicates error
    if(connect(s,(sockaddr*)&addr,sizeof(addr))!=0)
	{	
		settingsInfo->errorString = _tcsdup(TEXT("Connect Failed"));
		return false;
	}

	//recieve greeting message from server after connection is initialized
	//recieve greeting message from server after connection is initialized
	recv(s,greeting,sizeof(greeting),0);

	//set up the USER command
	POPcommand = "USER ";
	commandMsg = POPcommand + userSTR + CRLFstr;
	mBuf = (char*)commandMsg.c_str();
	//Send USER command
	send(s,mBuf,commandMsg.length(),0);
	//recv(s,rcv,strlen(rcv),0);
	strcpy(rcv,read_from_socket(s));

	//set up PASS command
	POPcommand = "PASS ";
	commandMsg = POPcommand + passSTR + CRLFstr;
	mBuf = (char*)commandMsg.c_str();
	//send PASS command
	send(s,mBuf,commandMsg.length(),0);
	//receive status of login
	//recv(s,rcv,strlen(rcv),0);
	strcpy(rcv,read_from_socket(s));
			
	//Check to see if username and password succeeds in logging into POP server
	if (rcv[0] == '+')	
	{
		//quit POP connection and clean up socket info before leaving
		
		//set up POP logout command
		POPcommand = "QUIT ";
		commandMsg = POPcommand + CRLFstr;
		mBuf = (char*)commandMsg.c_str();
		//send log out and recieve ack
		send(s,mBuf,commandMsg.length(),0);
		recv(s,rcv,sizeof(rcv),0);

		//closesocket() closes the socket and releases the socket descriptor
		closesocket(s);

		//cleanup socket info
		WSACleanup();	

		return true;}	//string starts with +OK if valid
	else 
	{	
		//quit POP connection and clean up socket info before leaving

		//set up POP logout command
		POPcommand = "QUIT ";
		commandMsg = POPcommand + CRLFstr;
		mBuf = (char*)commandMsg.c_str();
		//send log out and recieve ack
		send(s,mBuf,commandMsg.length(),0);
		recv(s,rcv,sizeof(rcv),0);

		//closesocket() closes the socket and releases the socket descriptor
		closesocket(s);

		//cleanup socket info
		WSACleanup();
		settingsInfo->errorString = _tcsdup(TEXT("UserID or Password is incorrect"));
		return false;}

	//if we got here something went wrong, return false to be safe
	return false;
}

SAMPLEPLUGIN_API BOOL UserLogin(LPTSTR Username, LPTSTR Password, pGinaInfo *settingsInfo) {
	char *hostAddresses = convert_to_char(regReadString(TEXT("host")));
	char *list;
	char *temp = NULL;
	bool authenticated = false;

	list = strdup(hostAddresses);
	
	if(!strstr(list,";")) {
		free(list);
		return testUserLogin(convert_to_char(Username), convert_to_char(Password), hostAddresses,settingsInfo);
	} else {
		temp = strtok(list,";");
		while(temp && !authenticated) {
			authenticated = testUserLogin(convert_to_char(Username), convert_to_char(Password), temp,settingsInfo);
			temp = strtok(NULL,";");
		}
	}

	if(authenticated) 
		settingsInfo->errorString = NULL;

	free(list);
	return authenticated;
}

SAMPLEPLUGIN_API BOOL ChangeUserPassword(LPTSTR Username,LPTSTR OldPassword,LPTSTR NewPassword) {
	return true;
}

SAMPLEPLUGIN_API LPCTSTR AboutPlugin(void)
{
	return VERSION;
}

SAMPLEPLUGIN_API void ChangePluginSettings(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	CConfigDialog *myDialog = new CConfigDialog();
	myDialog->DoModal();
}

SAMPLEPLUGIN_API void LoginHook(pGinaInfo *settingsInfo)
{
}

SAMPLEPLUGIN_API void LogoutHook(pGinaInfo *settingsInfo)
{
}

SAMPLEPLUGIN_API BOOL IsRequired(void)
{
		return false;
}


/////////////////////////////////////////////////////////////////////////////
// CSamplePluginApp

BEGIN_MESSAGE_MAP(CSamplePluginApp, CWinApp)
	//{{AFX_MSG_MAP(CSamplePluginApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSamplePluginApp construction

CSamplePluginApp::CSamplePluginApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSamplePluginApp object

CSamplePluginApp theApp;
