// PostgreSQLAuthGina.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "PostgreSQLAuthGina.h"
#include <wchar.h>
#include <libpq-fe.h>
#include "ConfigurationDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// We have options for MD5('password'), or of course, plaintext
POSTGRSQLAUTH_API BOOL UserLogin (LPTSTR Username, 
								  LPTSTR Password, 
								  pGinaInfo *settingsInfo) 
{
	LPTSTR host, password, username, db, table, user_field, pass_field, port, isadmin_field,
		   usergrp_field, allowpwdchg_field;
	char   *chost, *cport, *cpassword, *cusername, *cdb, *ctable, *cuser_field, *cpass_field,
		   *cisadmin_field, *cusergrp_field, *callowpwdchg_field;
	DWORD  pass_type;
	bool   Ok = true;

	// There must be a username AND password value
	if (Username == NULL || Password == NULL)
	{
		return false;
	}
	
	host              = regReadString (TEXT("host"));
	port              = regReadString (TEXT("port"));
	password          = regReadString (TEXT("password"));
	username          = regReadString (TEXT("username"));
	db                = regReadString (TEXT("db"));
	table             = regReadString (TEXT("table"));
	user_field        = regReadString (TEXT("user_field"));
	pass_field        = regReadString (TEXT("pass_field"));
	pass_type         = regReadDword (TEXT("pass_type"));
	isadmin_field     = regReadString (TEXT("isadmin_field"));
	usergrp_field     = regReadString (TEXT("usergrp_field"));
	allowpwdchg_field = regReadString (TEXT("allowpwdchg_field"));

	chost              = convert_to_char (host);	
	cport              = convert_to_char (port);	
	cpassword          = convert_to_char (password);
	cusername          = convert_to_char (username);
	cdb                = convert_to_char (db);
	ctable             = convert_to_char (table);
	cuser_field        = convert_to_char (user_field);
	cpass_field        = convert_to_char (pass_field);
	cisadmin_field     = convert_to_char (isadmin_field);
	cusergrp_field     = convert_to_char (usergrp_field);
	callowpwdchg_field = convert_to_char (allowpwdchg_field);

	char Con[255];
	sprintf (Con, "hostaddr=\'%s\' port=\'%s\' dbname=\'%s\' user=\'%s\' password=\'%s\' connect_timeout=\'10\'\0", 
			 chost, cport, cdb, cusername, cpassword);

	PGconn * PG = PQconnectdb (Con);
	if (PG == NULL)
	{
		return false;
	}

	if (pass_type == 0) // default to plain txt
	{
		sprintf (Con, "select * from %s where %s=\'%s\' and %s=\'%s\';\0",
				 ctable, cuser_field, convert_to_char (Username), cpass_field, 
				 convert_to_char (Password));
	}
	else if (pass_type == 1) // if we should MD5
	{
		sprintf (Con, "select * from %s where %s=\'%s\' and %s=md5(\'%s\');\0",
				 ctable, cuser_field, convert_to_char (Username), cpass_field, 
				 convert_to_char (Password));
	}
	else
	{
		Ok = false;
	}
	if (Ok)
	{
		PGresult * Result = PQexec (PG, Con);
		if (Result == NULL)
		{
			Ok = false;
		}
		if (Ok)
		{
			ExecStatusType Status = PQresultStatus (Result);
			if (Status != PGRES_TUPLES_OK )
			{
				Ok = false;
			}
			if (Ok)
			{
				if (PQntuples (Result) == 0)
				{
					Ok = false;
				}
				else if (settingsInfo != NULL)
				{
					int iColumn;
					char *cValue;

					settingsInfo->isAdmin = false;
					iColumn = PQfnumber (Result, cisadmin_field);
					if (iColumn != -1)
					{
						cValue = PQgetvalue (Result, 0, iColumn);
						if (cValue[0] == 't')
						{
							settingsInfo->isAdmin = true;
						}
					}

					settingsInfo->allowPassChange = false;
					iColumn = PQfnumber (Result, callowpwdchg_field);
					if (iColumn != -1)
					{
						cValue = PQgetvalue (Result, 0, iColumn);
						if (cValue[0] == 't')
						{
							settingsInfo->allowPassChange = true;
						}
					}

					iColumn = PQfnumber (Result, cusergrp_field);
					if (iColumn != -1)
					{
						settingsInfo->userGroups = convert_to_wchar (PQgetvalue (Result, 0, iColumn));
					}

				}
			}
			PQclear (Result);
		}
	}
	PQfinish (PG);
	return Ok;
}

POSTGRSQLAUTH_API BOOL ChangeUserPassword (LPTSTR Username,
										   LPTSTR OldPassword,
										   LPTSTR NewPassword) 
{
	LPTSTR host, password, username, db, table, user_field, pass_field, port;
	char   *chost, *cport, *cpassword, *cusername, *cdb, *ctable, *cuser_field, *cpass_field;
	DWORD  pass_type;
	bool   Ok = true;

	host       = regReadString (TEXT("host"));
	port       = regReadString (TEXT("port"));
	password   = regReadString (TEXT("password"));
	username   = regReadString (TEXT("username"));
	db         = regReadString (TEXT("db"));
	table      = regReadString (TEXT("table"));
	user_field = regReadString (TEXT("user_field"));
	pass_field = regReadString (TEXT("pass_field"));
	pass_type  = regReadDword (TEXT("pass_type"));

	chost       = convert_to_char (host);	
	cport       = convert_to_char (port);	
	cpassword   = convert_to_char (password);
	cusername   = convert_to_char (username);
	cdb         = convert_to_char (db);
	ctable      = convert_to_char (table);
	cuser_field = convert_to_char (user_field);
	cpass_field = convert_to_char (pass_field);

	char Con[255];
	sprintf (Con, "hostaddr=\'%s\' port=\'%s\' dbname=\'%s\' user=\'%s\' password=\'%s\' connect_timeout=\'10\'\0", 
			 chost, cport, cdb, cusername, cpassword);

	PGconn * PG = PQconnectdb (Con);
	if (PG == NULL)
	{
		return false;
	}

	if (pass_type == 0) // default to plain txt
	{
		sprintf (Con, "update %s set %s=\'%s\' where %s=\'%s\' and %s=\'%s\';\0",
				 ctable, cpass_field, convert_to_char (NewPassword), 
				 cuser_field, convert_to_char (Username), cpass_field, 
				 convert_to_char (OldPassword));
	}
	else if (pass_type == 1) // if we should MD5
	{
		sprintf (Con, "update %s set %s=md5(\'%s\') where %s=\'%s\' and %s=md5(\'%s\');\0",
				 ctable, cpass_field, convert_to_char (NewPassword), 
				 cuser_field, convert_to_char (Username), cpass_field, 
				 convert_to_char (OldPassword));
	}
	else
	{
		Ok = false;
	}


	if (Ok)
	{
		PGresult * Result = PQexec (PG, Con);
		if (Result == NULL)
		{
			Ok = false;
		}

		if (Ok)
		{
			ExecStatusType Status = PQresultStatus (Result);
			if (Status != PGRES_COMMAND_OK)
			{
				Ok = false;
			}
			PQclear (Result);
		}
	}

	PQfinish (PG);
	// call UserLogin again to check if the password has been changed 
	// successfully. PQresultStatus doesn't indicate if the UPDATE has
	// been performed or not
	return UserLogin (Username, NewPassword, NULL);
}

POSTGRSQLAUTH_API LPCTSTR AboutPlugin(void)
{
	return _tcsdup(TEXT(ABOUT_TEXT));
}

POSTGRSQLAUTH_API void ChangePluginSettings (void)
{
	// DO NOT PUT CODE BEFORE THIS!
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	// All code must follow this statement or crashing will ensue ;)
	CConfigurationDialog *myDlg = new CConfigurationDialog();
    int nRet = -1;
	nRet = myDlg->DoModal ();
}

POSTGRSQLAUTH_API void LoginHook (pGinaInfo *settingsInfo)
{
}

POSTGRSQLAUTH_API void LogoutHook (pGinaInfo *settingsInfo)
{
}

POSTGRSQLAUTH_API BOOL IsRequired (void)
{
	if (regReadBool (TEXT("required")))
	{
		return true;
	}
	else
	{
		return false;
	}
}

/**
	@brief	Writes a string to the registry
	@author Nathan Yocom
    
    Writes the passed string to the indicated value under HKLM\\SOFTWARE\\pGina
    
    @param  value       String to store
    @param  location    Name of the value to save
    
    @retval boolean Inidicates success of failure
*/
BOOL regWriteString (LPTSTR value, LPCTSTR location)
{
    HKEY hKey;
    
    if (RegCreateKeyEx (HKEY_LOCAL_MACHINE, _T("SOFTWARE\\pGina\\PostgreSQLAuth"),
					    0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL,
					    &hKey, NULL) == ERROR_SUCCESS)
    {
        if (value != NULL)
            if (RegSetValueEx (hKey, location, 0, REG_SZ, (CONST BYTE *) value, 
							   _tcslen(value)*sizeof(TCHAR)) == ERROR_SUCCESS)
            {
                RegFlushKey (hKey);
                RegCloseKey (hKey);
                return true;
            }
    }
    
    RegFlushKey (hKey);
    RegCloseKey (hKey);
    return false;
}

/**
	@brief	Writes a boolean (as dword) to the registry
	@author Nathan Yocom
    
    Writes the passed boolean to the indicated value under HKLM\\SOFTWARE\\pGina
    
    @param  value       Boolean to store
    @param  location    Name of the value to save
    
    @retval boolean Inidicates success of failure
*/
BOOL regWriteBool (BOOL value, LPCTSTR location)
{
    HKEY hKey;
    DWORD write;
	
    write = (value ? 1 : 0);
        
	if (RegCreateKeyEx (HKEY_LOCAL_MACHINE, _T("SOFTWARE\\pGina\\PostgreSQLAuth"),
					    0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL,
						&hKey, NULL) == ERROR_SUCCESS)
        if (RegSetValueEx (hKey, location, 0, REG_DWORD, (LPBYTE)&write,
						   sizeof(DWORD)) == ERROR_SUCCESS)
        {
            RegFlushKey (hKey);
            RegCloseKey (hKey);
            return true;
        }
    RegFlushKey (hKey);
    RegCloseKey (hKey);
    return false;
}

/**
	@brief	Reads a string to the registry
	@author Nathan Yocom
    
    Reads the indicated location under HKLM\\Software\\pGina and return it
    
    @param  location    Name of the value to read
    
    @retval TCHAR*  A newly allocated TCHAR[] with the read value (up to 2048 chars)
    
    @bug    Buffer expansion issue here?
*/
TCHAR * regReadString (LPCTSTR location)
{
    LONG lResult;
	HKEY hKey;
    DWORD dwBytesRead = 2048;
    TCHAR result[2048];
    TCHAR *ret;

    lResult = RegOpenKeyEx (HKEY_LOCAL_MACHINE, _T("SOFTWARE\\pGina\\PostgreSQLAuth"),
							0, KEY_QUERY_VALUE, &hKey);
    
    if (lResult == ERROR_SUCCESS)
    {
    	lResult = RegQueryValueEx (hKey, location, NULL, NULL, (LPBYTE)&result,
								   &dwBytesRead);
        
        if (lResult == ERROR_SUCCESS)
        {
            if (dwBytesRead > 0)
            {
				if (!_tcscmp (result, TEXT(""))) // If its just a space
				{
				    return NULL;                                                                                 
				}
				else
				{
					ret = (TCHAR *)malloc((sizeof(TCHAR) * dwBytesRead) + 1);
					ret = _tcsdup (result);
					RegCloseKey (hKey);
					return ret;
				}
            }
            else
            {
                return NULL;
            }
        }
    }
    RegCloseKey (hKey);
    return NULL;
}

/**
	@brief	Load a bool value from the HKLM/pGina registry
	@author Nathan Yocom
    
    @param location The key to load
*/
BOOL regReadBool (LPCTSTR location)
{
    LONG lResult;
	HKEY hKey;
    DWORD value = 0;
    DWORD size = sizeof(DWORD);

    lResult = RegOpenKeyEx (HKEY_LOCAL_MACHINE, _T("SOFTWARE\\pGina\\PostgreSQLAuth"),
							0, KEY_QUERY_VALUE, &hKey);
    
    if(lResult == ERROR_SUCCESS)
    {
    	lResult = RegQueryValueEx (hKey, location, NULL, NULL, (LPBYTE)&value, &size);
        
        if(lResult == ERROR_SUCCESS)
        {
            RegCloseKey (hKey);
            if(value == 1) 
			{
                return true;
			}
            else
			{
                return false;
			}
        }
    }
    RegCloseKey (hKey);
    return false;
}

BOOL regWriteDword (DWORD value,LPCTSTR location)
{
    HKEY hKey;
    DWORD write;
	
    write = value;
        
	if (RegCreateKeyEx (HKEY_LOCAL_MACHINE, _T("SOFTWARE\\pGina\\PostgreSQLAuth"),
						0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL,
						&hKey, NULL) == ERROR_SUCCESS)
        if (RegSetValueEx (hKey, location, 0, REG_DWORD, (LPBYTE)&write,
						   sizeof(DWORD)) == ERROR_SUCCESS)
        {
            RegFlushKey (hKey);
            RegCloseKey (hKey);
            return true;
        }
    RegFlushKey (hKey);
    RegCloseKey (hKey);
    return false;
}

DWORD regReadDword (LPCTSTR location)
{
    LONG lResult;
	HKEY hKey;
    DWORD value = 0;
    DWORD size = sizeof(DWORD);

    lResult = RegOpenKeyEx (HKEY_LOCAL_MACHINE, _T("SOFTWARE\\pGina\\PostgreSQLAuth"),
							0, KEY_QUERY_VALUE, &hKey);
    
    if (lResult == ERROR_SUCCESS)
    {
    	lResult = RegQueryValueEx (hKey, location, NULL, NULL, (LPBYTE)&value, &size);
        
        if (lResult == ERROR_SUCCESS)
        {
            RegCloseKey (hKey);
            return value;
        }
    }
    RegCloseKey (hKey);
    return 0;
}

char * convert_to_char (const TCHAR *from)
{
	if (from == NULL)
	{
		return NULL;
	}
	char *to = (char *) malloc(2048);
	
	WideCharToMultiByte (CP_ACP,
						 NULL,
						 (LPCWSTR)from,
						 -1,
						 to,
						 2048,
						 NULL,
						 NULL);
	
	return to;
}

LPTSTR convert_to_wchar(const char *from)
{
	TCHAR *to;
	if (from == NULL)
	{
		return NULL;
	}
	
	to = (TCHAR *) malloc(strlen(from)*sizeof(TCHAR));
	int i = MultiByteToWideChar (CP_ACP, NULL, (LPCSTR)from,
								 -1, (LPWSTR)to, 0);					
	MultiByteToWideChar (CP_ACP, NULL, (LPCSTR)from, -1,
						 (LPWSTR)to, i);					

	return to;
}

BEGIN_MESSAGE_MAP(CPostgreSQLAuthGinaApp, CWinApp)
END_MESSAGE_MAP()


// CPostgreSQLAuthGinaApp construction
CPostgreSQLAuthGinaApp::CPostgreSQLAuthGinaApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CPostgreSQLAuth_App object
CPostgreSQLAuthGinaApp theApp;


// CPostgreSQLAuthGinaApp initialization

BOOL CPostgreSQLAuthGinaApp::InitInstance ()
{
	CWinApp::InitInstance();

	return TRUE;
}
