/*
pGina PostgreSQLAuth code - based upon skeleton code for pGina plugin development
Copyright (C) 2006 Fabien Milcent

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

Email: fabien_milcent@yahoo.fr
*/
// PostgreSQLAuthGina.h : main header file for the POSTGRESQLAUTHGINA DLL
//

#if !defined(AFX_POSTGRESQLAUTHGINA_H__DC6F4E6D_73EF_48DF_81BE_38018EED9F27__INCLUDED_)
#define AFX_POSTGRESQLAUTHGINA_H__DC6F4E6D_73EF_48DF_81BE_38018EED9F27__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

#define POSTGRSQLAUTH_API extern "C" __declspec(dllexport)
#define POSTGRESQLAUTHVERSION "PostgreSQLAuth Version 1.1 by Fabien Milcent"
#define ABOUT_TEXT "PostgreSQL Auth 1.1 pGina Plugin by Fabien Milcent, fabien_milcent@yahoo.fr"
typedef struct pGinaInfo {
		LPTSTR pathMSGina;
		LPTSTR pathPlugin;
		LPTSTR pathProfile;
		LPTSTR mapPaths;
		LPTSTR Username;
		LPTSTR Password;
		LPTSTR homeDir;
		BOOL isAdmin;
		BOOL disabled;
		int authType;
		HANDLE hUser;
		LPTSTR userGroups;
		LPTSTR userDescription;
		LPTSTR userFullName;
		BOOL allowPassChange;
		LPTSTR errorString;
		LPTSTR defaultDomain;
		BOOL Reserved3;
		BOOL Reserved4;
} pGinaInfo ;


POSTGRSQLAUTH_API BOOL UserLogin (LPTSTR, LPTSTR, pGinaInfo *);			
POSTGRSQLAUTH_API BOOL ChangeUserPassword (LPTSTR, LPTSTR, LPTSTR);
POSTGRSQLAUTH_API LPCTSTR AboutPlugin (void);
POSTGRSQLAUTH_API void ChangePluginSettings (void);
POSTGRSQLAUTH_API void LoginHook (pGinaInfo *);
POSTGRSQLAUTH_API void LogoutHook (pGinaInfo *);
POSTGRSQLAUTH_API BOOL IsRequired (void);


TCHAR * regReadString (LPCTSTR);
BOOL regWriteString (LPTSTR, LPCTSTR);
BOOL regReadBool (LPCTSTR);
BOOL regWriteBool (BOOL, LPCTSTR);
BOOL regWriteDword (DWORD, LPCTSTR);
DWORD regReadDword (LPCTSTR);

LPTSTR convert_to_wchar (const char *);
char * convert_to_char (const TCHAR *);

// CPostgreSQLAuth_App
// See PostgreSQLAuthGina.cpp for the implementation of this class
//
class CPostgreSQLAuthGinaApp : public CWinApp
{
public:
	CPostgreSQLAuthGinaApp();

// Overrides
public:
	virtual BOOL InitInstance ();

	DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_POSTGRESQLAUTHGINA_H__DC6F4E6D_73EF_48DF_81BE_38018EED9F27__INCLUDED_)
