/*
Symbol Modification Plugin for pGina
Copyright (C) 2004 Nathan Yocom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Email: nate.yocom@xpasystems.com
Web: http://pgina.xpasystems.com
Snail Mail:
  Nathan Yocom 
  19 Foxwell Drive
  Scarborough, ME 04074
  Phone: 207-450-4948
*/

/**************************************************************************************
 * Development of this plugin was sponsored by an anonymous donor and I would
 *  like to acknowledge their support and thank them for pursuing its creation.
 **************************************************************************************/

#ifdef SYMBOLMOD_EXPORTS
#define SYMBOLMOD_API extern "C" __declspec(dllexport)
#else
#define SYMBOLMOD_API extern "C" __declspec(dllimport)
#endif

#include <wchar.h>
#include <tchar.h>
#include <windows.h>
#include	<Winreg.h>
#include 	<stdlib.h>
#include	<stdio.h>

HANDLE gHandle;

/**
 * pGina Info structure, as defined by the pGina plugin API
 */
typedef struct pGinaInfo {
		LPTSTR pathMSGina;
		LPTSTR pathPlugin;
		LPTSTR pathProfile;
		LPTSTR mapPaths;
		LPTSTR Username;
		LPTSTR Password;
		LPTSTR homeDir;
		BOOL isAdmin;
		BOOL disabled;
		int authType;
		HANDLE hUser;
		LPTSTR userGroups;
		LPTSTR userDescription;
		LPTSTR userFullName;
		BOOL allowPassChange;
		LPTSTR errorString;
		LPTSTR defaultDomain;
		BOOL Reserved3;
		BOOL Reserved4;
} pGinaInfo ;


/**
 * Required pGina Plugin Exported Functions
 */
SYMBOLMOD_API BOOL UserLogin(LPTSTR, LPTSTR, pGinaInfo *);			
SYMBOLMOD_API BOOL ChangeUserPassword(LPTSTR,LPTSTR,LPTSTR);
SYMBOLMOD_API LPCTSTR AboutPlugin(void);
SYMBOLMOD_API void ChangePluginSettings(void);
SYMBOLMOD_API void LoginHook(pGinaInfo *);
SYMBOLMOD_API void LogoutHook(pGinaInfo *);
SYMBOLMOD_API BOOL IsRequired(void);

/**
 * Registry/settings handling functions
 */
TCHAR * regReadString(LPCTSTR location);
TCHAR * regReadStringDefault(LPCTSTR location, TCHAR * defaultVal);
BOOL regWriteString(LPTSTR value,LPCTSTR location);
BOOL regWriteDword(DWORD value,LPCTSTR location);
DWORD regReadDword(LPCTSTR location);
BOOL regReadBool(LPCWSTR location);
BOOL regWriteBool(BOOL value,LPCTSTR location);
void regDelValue(LPCTSTR location);

/**
 * Dialog Stuff
 */
VOID CenterWindow(HWND hwnd);
BOOL CALLBACK ConfigBoxProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam);

/**
 * Character handling
 */
char * convert_to_char(const TCHAR *from);
TCHAR * convert_to_wchar(const char *from);
