/*
pGina WebAuth plugin - Authenticates user to a website via HTTPS.
Copyright (C) 2004 Jason M. Kikta, Micah Cooper

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

http://pgina.xpasystems.com/
Email: kiktajm@muohio.edu, coopermj@muohio.edu
*/

// WebAuthPlug.cpp : Defines the entry point for the DLL application.

#include "stdafx.h"
#include "WebAuthPlug.h"

#include <wchar.h> //I hate strings.
#include <tchar.h> //I HATE STRINGS!!!
#include <atlbase.h> //For using the Registry. :-P
#include <string> //I HAT TEH STRINGES!!! DIE! DIEDIE! DIE!!!!!!

//For LookupAdminName
#include <windows.h>
#include <lm.h>
#include <stdio.h>

#using <system.dll>
#using <mscorlib.dll>

//Wacky!
using namespace System;
using namespace System::IO;
using namespace System::Runtime::InteropServices;
//Our C# code to get and parse the webpage.
using namespace getPage;

// This isn't strictly necessary, but can be handy if you are going to add Dialog's etc
BOOL APIENTRY DllMain( HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
	//LogoutHook(NULL);

    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

/**
	@brief	Writes a string to the registry
	@author Nathan Yocom
    
    Writes the passed string to the indicated value under HKLM\\SOFTWARE\\pGina\\WebAuth
    
    @param  value       String to store
    @param  location    Name of the value to save
    
    @retval boolean Inidicates success of failure
*/
WEBAUTHPLUG_API BOOL regWriteString(LPTSTR value,LPCTSTR location)
{
    HKEY hKey;
    
    if(RegCreateKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\WebAuth"),0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&hKey,NULL) == ERROR_SUCCESS)
    {
        if(value != NULL)
            if(RegSetValueEx(hKey,location,0,REG_SZ,(CONST BYTE *) value, _tcslen(value)*sizeof(TCHAR)) == ERROR_SUCCESS)
            {
                RegFlushKey(hKey);
                RegCloseKey(hKey);
                return true;
            }
    }
    
    RegFlushKey(hKey);
    RegCloseKey(hKey);
    return false;
}

/**
	@brief	Reads a string to the registry
	@author Nathan Yocom
    
    Reads the indicated location under HKLM\\SOFTWARE\\pGina\\WebAuth and return it
    
    @param  location    Name of the value to read
    
    @retval TCHAR*  A newly allocated TCHAR[] with the read value (up to 2048 chars)
    
    @bug    Buffer expansion issue here?
*/

WEBAUTHPLUG_API TCHAR * regReadString(LPCTSTR location)
{
    LONG lResult;
	HKEY hKey;
    DWORD dwBytesRead = 2048;
    TCHAR result[2048];
    TCHAR *ret;

    lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\pGina\\WebAuth"),0,KEY_QUERY_VALUE,&hKey);
    
    if(lResult == ERROR_SUCCESS)
    {
    	lResult = RegQueryValueEx(hKey,location,NULL,NULL,(LPBYTE)&result,&dwBytesRead);
        
        if(lResult == ERROR_SUCCESS)
        {
            if(dwBytesRead > 0)
            {			
				if(!_tcscmp(result,TEXT(""))) // If its just a space
				{
					RegCloseKey(hKey);
				    return NULL;                                                                                 
				}
				else
				{
				    //ret = (TCHAR *)malloc((sizeof(TCHAR) * dwBytesRead) + 1);
					ret = _tcsdup(result);
					RegCloseKey(hKey);
					return ret;
				}
            }
            else
            {
				RegCloseKey(hKey);
                return NULL;
            }
        }
    }
    RegCloseKey(hKey);
    return NULL;
}

WEBAUTHPLUG_API BOOL UserLogin(LPTSTR Username, LPTSTR Password, pGinaInfo *settingsInfo)
{
	//Logout first, so as to not use someone else's session.
	LogoutHook();

	//Check to see if the local Administrator is logging on, so we can skip everything else
	WCHAR adminName[UNLEN+1];
	LookupAdminName(adminName); //defined down south of here - don't look unless you hate yourself

	if(wcsicmp(adminName, Username) == 0)
	{
		return false; //Hello, Root. Where would you like to go today? To SuSE.com? Excellent.
	}
	//Not Administrator, so continue on...

	//Need two of these suckers, because one is too long, due to the fact that Windows is teh suck.
	String *LoginURI0;
	String *LoginURI1;
	//Username & password passed in by pGina
	String *uname		  = Marshal::PtrToStringAuto(Username);
	String *pass		  = Marshal::PtrToStringAuto(Password);
	//Stuff read from the Registry
	String *Protocol_type	= Marshal::PtrToStringAuto(regReadString(_T("URI_01_Protocol_type")));
	String *WebAuth_IP		= Marshal::PtrToStringAuto(regReadString(_T("URI_02_WebAuth_IP_0")));
	String *Param01			= Marshal::PtrToStringAuto(regReadString(_T("URI_03_Param01")));
	String *Param02			= Marshal::PtrToStringAuto(regReadString(_T("URI_04_Param02")));

	//Create the login URI in two steps, or it chokes (teh suck!!!)
	LoginURI0 = String::Concat(Protocol_type, WebAuth_IP, Param01);
	LoginURI1 = String::Concat(LoginURI0, uname, Param02, pass);
	
	HttpRequest *login_page = new HttpRequest(); //These *should* be garbage collected.
    String	*body_string; //the page we get back
    String	*parsed_string; //the results of running the regex on the page

	WCHAR error_string[1024]; // a string for our error
	error_string[0] = NULL; //initializing it (screw this, I'm sticking to Perl from now on)

	bool	allow_login	= false; //can we login?
	LPTSTR	logout_uri  = NULL; //URI for logout

	//Send our URI & see what we get back...
	body_string = login_page->getUri(LoginURI1);

	//Getting our error strings from the Registry.
	String *RX_STR_UNREACHABLE	= Marshal::PtrToStringAuto(regReadString(_T("RX_STR_UNREACHABLE")));
	String *RX_STR_ERROR_LVL	= Marshal::PtrToStringAuto(regReadString(_T("RX_STR_ERROR_LVL")));
	String *RX_STR_ERROR_LVL_0	= Marshal::PtrToStringAuto(regReadString(_T("RX_STR_ERROR_LVL_0")));
	String *RX_STR_ERROR_LVL_1	= Marshal::PtrToStringAuto(regReadString(_T("RX_STR_ERROR_LVL_1")));
	String *RX_STR_LOGOUT_FIELD	= Marshal::PtrToStringAuto(regReadString(_T("RX_STR_LOGOUT_FIELD")));
	String *RX_STR_ERROR_FIELD	= Marshal::PtrToStringAuto(regReadString(_T("RX_STR_ERROR_FIELD")));
	
	//Can we reach the damn thing?
	if (0 == String::Compare(body_string, RX_STR_UNREACHABLE))
	{
		//Ok, let's try some different servers...		
		WCHAR ip_addr[256];
		WCHAR num[32];
		ULONG i = 0;
		TCHAR *regKey;

		while(true) //True? Yes.
		{		
			i++;
			_itow(i, num, 10);
			wcscpy(ip_addr, _T("URI_02_WebAuth_IP_"));
			wcscat(ip_addr, num);
			regKey = regReadString(ip_addr);
			
			if(regKey == NULL) //This means we ran out of Registry keys without reaching a server
			{
				//Couldn't get there - sucks to be you.
				parsed_string = "UNREACHABLE";
				break; //Time to go move on & tell you that you suck...
			}

			WebAuth_IP = Marshal::PtrToStringAuto(regKey);
			LoginURI0 = String::Concat(Protocol_type, WebAuth_IP, Param01);
			LoginURI1 = String::Concat(LoginURI0, uname, Param02, pass);
            
			body_string = login_page->getUri(LoginURI1); //give it a whirl...
			
			if (0 != String::Compare(body_string, RX_STR_UNREACHABLE)) //Hey! We got one!
			{
				parsed_string = login_page->parseRegex(body_string, RX_STR_ERROR_LVL);
				break; //"You know you make me wanna Break-ouuuut!" (Listening to Foo-Fighters, ironic, no?)
			}
		}
	}
	else
	{
		//Now we're using a regex to parse for the first set of tags (which should be an error level).
		parsed_string = login_page->parseRegex(body_string, RX_STR_ERROR_LVL);
	}


	//*Cause*: Succesful login to WebAuth.
	if (0 == String::Compare(parsed_string, RX_STR_ERROR_LVL_0))
	{
		parsed_string = login_page->parseRegex(body_string, RX_STR_LOGOUT_FIELD);
		
		//Converting the logout URI from a C# string object to a C++ LPTSTR.
		wchar_t * szMessage = (wchar_t *)(void *)Marshal::StringToHGlobalUni(parsed_string);
		logout_uri = wcsdup(szMessage);
		Marshal::FreeHGlobal(szMessage);
		
		//Now we need to store this in the Registry for logout.
		BOOL reg_write_success = regWriteString(logout_uri, _T("WebAuth_LogoutURI"));

		allow_login = true;
	}
	//*Cause*:  Unsuccessful login to WebAuth.
	else if (0 == String::Compare(parsed_string, RX_STR_ERROR_LVL_1))
	{
		parsed_string = login_page->parseRegex(body_string, RX_STR_ERROR_FIELD);

		//Get string values from Registry for values within RX_STR_ERROR_FIELD.
		String *badip	= Marshal::PtrToStringAuto(regReadString(_T("ERROR_Bad_IP")));
		String *baduserpass	= Marshal::PtrToStringAuto(regReadString(_T("ERROR_Bad_UserOrPass")));

		//*Cause*: Bad username or password.
		if (0 == String::Compare(parsed_string, baduserpass))
		{
			wcscpy(error_string, L"Invalid Username or Password."); //TAKE OFF EVERY CAPS LOCK, FOR GREAT JUSTICE!
			allow_login = false;
		}
		//*Cause*: Bad IP for WebAuth.
		else if (0 == String::Compare(parsed_string, badip))
		{
			wcscpy(error_string, L"Invalid IP for Wireless Access."); //You're wired, Fool!
			allow_login = false;
		}
		//*Cause*: Site sent an error we don't understand (Big Surprise).
		else
		{
			wcscpy(error_string, L"Unknown error message returned from site.");
			allow_login = false;
		}
	}
	//*Cause*: This mean we got no response or something like a 404.
	else if (0 == String::Compare(parsed_string, "UNREACHABLE"))
	{
		wcscpy(error_string, L"Unable to reach login page."); //Yup, you're screwed.
		allow_login = false;
	}
	//*Cause*: This means that we either got somthing new from the website,
	//         we couldn't connect, or some other bizzareness happened.
	else
	{
		wcscpy(error_string, L"An unknown error has occured. Good luck, you'll need it."); //YOU.. ARE... HOSED!
		allow_login = false;
	}

	settingsInfo->errorString = wcsdup(error_string); //pass PaGina (*snicker*) the error string


	//Time to pass on our decision.
	if(allow_login)
	{
		return true; //Lucky you... have fun in Windows (sucker!)
	}
	else
		return false; //Even Luckier! Install a *real* OS & be done with it!
}

WEBAUTHPLUG_API BOOL ChangeUserPassword(LPTSTR Username,LPTSTR OldPassword,LPTSTR NewPassword)
{
	return true;
}

WEBAUTHPLUG_API LPCTSTR AboutPlugin(void)
{
	// Return a sample descriptions string
	return TEXT("Authenticates user to a website via HTTPS. Copyright 2004 by Jason M. Kikta <kiktajm@muohio.edu> and Micah Cooper <coopermj@muohio.edu>.");
}

WEBAUTHPLUG_API void ChangePluginSettings(void)
{
	// Describe in a messagebox what this would do
	MessageBox(NULL,TEXT("No settings dialog at this time.\nLook in HKEY_LOCAL_MACHINE\\SOFTWARE\\pGina\\WebAuth for settings."),TEXT("ChangePluginSettings()"),MB_OK);
}

WEBAUTHPLUG_API void LoginHook(pGinaInfo *settingsInfo)
{

}

WEBAUTHPLUG_API void LogoutHook(void)
{
	HttpRequest	*logout_page = new HttpRequest();
	String	*LogoutURI;
	String	*body_string;

	LogoutURI = regReadString(_T("WebAuth_LogoutURI")); //Get logout URI from Registry.
	
	if (0 != String::Compare(LogoutURI, "null")) //if null, skip it
	{
		body_string = logout_page->getUri(LogoutURI); //logout, Biatch!
	}
}

WEBAUTHPLUG_API BOOL IsRequired(void)
{
	return false;
}

//Micah:
// Code shamefully stolen from MS to determine the local administrator name
// We don't actually need this to work, but it's good to know for such things such
// as when we don't want to do "work" for "special" users ;)
//Jason:
//The following was stolen in large part from MSDN by Micah & I.
//I tried to give it back, but they wouldn't take it.
//I don't blame them...
bool LookupAdminName(WCHAR *adminName)
{
	bool jsuccess = false;
	
	LPWSTR TargetComputer = NULL; // we only want our local affiliate
	DWORD Rid = DOMAIN_USER_RID_ADMIN; // Mr. Admin S. Trator (in the U.S.)
	
	WCHAR Name[UNLEN+1];
	DWORD cchName = UNLEN;

	LPWSTR Name2 = Name; //shoot me now - seriously

	PUSER_MODALS_INFO_2 umi2;
	NET_API_STATUS nas;

	UCHAR SubAuthorityCount;
	PSID pSid;
	SID_NAME_USE snu;

	WCHAR DomainName[DNLEN+1];
	DWORD cchDomainName = DNLEN;
	BOOL bSuccess = FALSE; // assume failure

	// 
	// get the account domain Sid on the target machine
	// note: if you were looking up multiple sids based on the same
	// account domain, only need to call this once.
	// 

	nas = NetUserModalsGet(TargetComputer, 2, (LPBYTE *)&umi2);

	if(nas != NERR_Success) {
		SetLastError(nas);
		return jsuccess;
	}

	SubAuthorityCount = *GetSidSubAuthorityCount
		(umi2->usrmod2_domain_id);

	// 
	// allocate storage for new Sid. account domain Sid + account Rid
	// 

	pSid = (PSID)HeapAlloc(GetProcessHeap(), 0,
		GetSidLengthRequired((UCHAR)(SubAuthorityCount + 1)));

	if(pSid != NULL) {

		if(InitializeSid(
			pSid,
			GetSidIdentifierAuthority(umi2->usrmod2_domain_id),
			(BYTE)(SubAuthorityCount+1)
			)) {

				DWORD SubAuthIndex = 0;

				// 
				// copy existing subauthorities from account domain Sid into
				// new Sid
				// 

				for( ; SubAuthIndex < SubAuthorityCount ; SubAuthIndex++) {
					*GetSidSubAuthority(pSid, SubAuthIndex) =
						*GetSidSubAuthority(umi2->usrmod2_domain_id,
						SubAuthIndex);
				}

				// 
				// append Rid to new Sid
				// 

				*GetSidSubAuthority(pSid, SubAuthorityCount) = Rid;

				bSuccess = LookupAccountSidW(
					TargetComputer,
					pSid,
					Name2,
					&cchName,
					DomainName,
					&cchDomainName,
					&snu
					);
				
				if(bSuccess)
				{
					wcscpy(adminName, Name);
					jsuccess = true;
				}
			}

			HeapFree(GetProcessHeap(), 0, pSid);
	}

	NetApiBufferFree(umi2);

	return jsuccess;
} 
