/*
pGina WebAuth plugin - Authenticates user to a website via HTTPS.
Copyright (C) 2004 Jason M. Kikta, Micah Cooper

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

http://pgina.xpasystems.com/
Email: kiktajm@muohio.edu, coopermj@muohio.edu
*/

#ifndef WEBAUTHPLUG_EXPORTS
#define WEBAUTHPLUG_EXPORTS
#endif
// Define macro's for exporting methods
#ifdef WEBAUTHPLUG_EXPORTS
#define WEBAUTHPLUG_API extern "C" __declspec(dllexport)
#else
#define WEBAUTHPLUG_API extern "C" __declspec(dllimport)
#endif

typedef struct pGinaInfo {
		LPTSTR pathMSGina;
		LPTSTR pathPlugin;
		LPTSTR pathProfile;
		LPTSTR mapPaths;
		LPTSTR Username;
		LPTSTR Password;
		LPTSTR homeDir;
		BOOL isAdmin;
		BOOL disabled; 
		int authType;
		HANDLE hUser;
		LPTSTR userGroups;
		LPTSTR userDescription;
		LPTSTR userFullName;
		BOOL allowPassChange;
		LPTSTR errorString;
		LPTSTR defaultDomain;
		BOOL Reserved3;
		BOOL Reserved4;
} pGinaInfo ;


// Export these methods... - REQUIRED
WEBAUTHPLUG_API BOOL UserLogin(LPTSTR, LPTSTR,pGinaInfo *);			
WEBAUTHPLUG_API BOOL ChangeUserPassword(LPTSTR,LPTSTR,LPTSTR);
WEBAUTHPLUG_API LPCTSTR AboutPlugin(void);
WEBAUTHPLUG_API void ChangePluginSettings(void);
WEBAUTHPLUG_API void LoginHook(pGinaInfo *);
WEBAUTHPLUG_API  void LogoutHook(void);


// Option method with the 1.6.x series and up of pGina
WEBAUTHPLUG_API BOOL IsRequired(void);

//All your sanity are belong to us!
bool LookupAdminName(WCHAR *adminName);