// PluginSetupDlg.h : header file
//

#include <windows.h>

#if !defined(AFX_PLUGINSETUPDLG_H__FE39B920_9AC2_4452_9646_07C5E865DC5B__INCLUDED_)
#define AFX_PLUGINSETUPDLG_H__FE39B920_9AC2_4452_9646_07C5E865DC5B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CPluginSetupDlg dialog

typedef struct pGinaInfo {
		LPTSTR pathMSGina;
		LPTSTR pathPlugin;
		LPTSTR pathProfile;
		LPTSTR mapPaths;
		LPTSTR Username;
		LPTSTR Password;
		LPTSTR homeDir;
		BOOL isAdmin;
		BOOL disabled;
		int authType;
		HANDLE hUser;
		LPTSTR userGroups;
		LPTSTR userDescription;
		LPTSTR userFullName;
		BOOL allowPassChange;
		LPTSTR errorString;
		LPTSTR defaultDomain;
		BOOL Reserved3;
		BOOL Reserved4;
} pGinaInfo;



// Export these methods...
typedef __declspec(dllimport)BOOL (*DLLUSERLOGIN)(LPTSTR, LPTSTR, pGinaInfo *);
typedef __declspec(dllimport)BOOL (*DLLCHANGEUSERPASSWORD) (LPTSTR,LPTSTR,LPTSTR);
typedef __declspec(dllimport)LPCTSTR (*DLLABOUTPLUGIN) (void);
typedef __declspec(dllimport)void (*DLLCHANGEPLUGINSETTINGS) (void);
typedef __declspec(dllimport)void (*DLLLOGINHOOK) (pGinaInfo *);
typedef __declspec(dllimport)void (*DLLLOGOUTHOOK) (pGinaInfo *);
typedef __declspec(dllimport)BOOL (*DLLCONFIGURE) (void);

typedef __declspec(dllimport)void (*DLLCHANGEHOOKSETTINGS) (void);
typedef __declspec(dllimport)LPSTR (*DLLABOUTHOOK) (void);
typedef __declspec(dllimport)BOOL (*DLLISREQUIRED) (void);

class CPluginSetupDlg : public CDialog
{
// Construction
public:
	CPluginSetupDlg(CWnd* pParent = NULL);	// standard constructor
	void CPluginSetupDlg::LoadFunctions(LPCTSTR);
	void CPluginSetupDlg::LoadHook(LPCTSTR);
	// MOVE TO NEW FILE?
	//
	// Function prototypes for the GINA interface.
	//
	DLLUSERLOGIN                dllUserLogin;
	DLLCHANGEUSERPASSWORD		dllChangeUserPassword;
	DLLABOUTPLUGIN				dllAboutPlugin;
	DLLCHANGEPLUGINSETTINGS		dllChangePluginSettings;
	DLLLOGINHOOK				dllLoginHook;
	DLLLOGOUTHOOK				dllLogoutHook;
	DLLCONFIGURE				pGinaConfigure; 
	DLLISREQUIRED				dllIsRequired;

	DLLCHANGEHOOKSETTINGS		hookChangeHookSettings;
	DLLABOUTHOOK				hookAboutHook;

	
	BOOL						dllLoaded;
	BOOL						hookLoaded;

	pGinaInfo					settingsInfo;
	
// Dialog Data
	//{{AFX_DATA(CPluginSetupDlg)
	enum { IDD = IDD_PLUGINSETUP_DIALOG };
	CString	m_AboutPlugin;
	CString	m_AboutHook;
	CString	m_userGroups;
	CString	m_homeDir;
	BOOL	m_isAdmin;
	CString	m_mapPaths;
	BOOL	m_allowPassChange;
	CString	m_info_password;
	CString	m_password;
	CString	m_new_password;
	CString	m_pathHook;
	CString	m_pathProfile;
	CString	m_username;
	CString	m_info_username;
	CString	m_domain;
	CString	m_errorstring;
	CString	m_req;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPluginSetupDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CPluginSetupDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	afx_msg void OnSettings();
	afx_msg void OnpGina();
	afx_msg void OnLoadHook();
	afx_msg void OnConfigureHook();
	afx_msg void OnLoginTest();
	afx_msg void OnLoginHook();
	afx_msg void OnLogoutHook();
	afx_msg void OnChangePass();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PLUGINSETUPDLG_H__FE39B920_9AC2_4452_9646_07C5E865DC5B__INCLUDED_)
