#include <stdio.h>
#include <stdlib.h>
#include <openssl/ssl.h>
#include "ssl_agent.h"

int main(int argc, char *argv[])
{
  SSL *ssl;
  SSL_CTX *ctx;
  BIO *conn;
  char *message_from_server;
  
  OpenSSL_add_all_algorithms();
  SSL_load_error_strings();
  
  ctx = SSL_CTX_new(TLSv1_method());
  if(!ctx) {
      
      fprintf(stderr, "Error - SSL CTX\n");
      exit(1);
  }
  
  ssl = SSL_new(ctx);
  if(!ssl) {
      fprintf(stderr, "Error - SSL new\n");
      exit(1);
  }
  
  conn = BIO_new_connect(argv[1]);
  
  if(!conn) {
      fprintf(stderr, "Error - BIO_new_connect\n");
      exit(2);
  }
  
  if(BIO_do_connect(conn) <= 0) {
      fprintf(stderr, "Error - BIO_do_connect\n");
      exit(2);
  }
  
  SSL_set_bio(ssl,conn,conn);
  
  if(SSL_connect(ssl) <= 0) {
      fprintf(stderr, "Error - SSL handshake\n");
      exit(1);
  }
  
  send_string(ssl,"!");
  message_from_server = read_string(ssl);
  printf ("OK\n");
  return 0;
}

