/*

	Copyright (C) 2004 University of Calgary

	

	Contact: Eric Parsons (ericpar@math.ucalgary.ca)



	This file is part of pgftp.



    pgftp is free software; you can redistribute it and/or modify

    it under the terms of the GNU General Public License as published by

    the Free Software Foundation; either version 2 of the License, or

    (at your option) any later version.



    pgftp is distributed in the hope that it will be useful,

    but WITHOUT ANY WARRANTY; without even the implied warranty of

    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

    GNU General Public License for more details.



    You should have received a copy of the GNU General Public License

    along with pgftp; if not, write to the Free Software

    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



 */



#include "stdafx.h"

#include "ftpfuncs.h"

#include "misc.h"



// See ftpfuncs.h for function descriptions



HINTERNET OpenProfileFtp(LPCTSTR server, LPCTSTR user, LPCTSTR password)

{

	HINTERNET hInternet = InternetOpen(TEXT("pGina"), INTERNET_OPEN_TYPE_DIRECT, NULL, NULL, 0);

					

	if (!hInternet) 

		return NULL;

	

	hInternet = InternetConnect(hInternet, server, INTERNET_DEFAULT_FTP_PORT, 

		user, password, INTERNET_SERVICE_FTP, 0, 0);

		

	return hInternet;

}





BOOL FtpCreatePath(HINTERNET hConnect, LPCTSTR path) {

	LPTSTR tempPath;

	int len = lstrlen(path);

	BOOL ret = TRUE;

	int i;

	DWORD le;



	tempPath = (LPTSTR)LocalAlloc(LMEM_FIXED, (len + 2) * sizeof(TCHAR));

	lstrcpy(tempPath, path);

	if (path[len - 1] != TEXT('/')) {

		// Force path to have terminating '/'

		len++;

		tempPath[len - 1] = TEXT('/');

		tempPath[len] = TEXT('\0');

	}

	

	for (i = 0; i < len; i++) {

		if (tempPath[i] == TEXT('/')) {

			tempPath[i] = TEXT('\0');

			ret = FtpCreateDirectory(hConnect, tempPath);

			le = GetLastError();

			tempPath[i] = TEXT('/');

		}

	}

	LocalFree(tempPath);



	return ret; 

}



// The following FTP-related functions are no longer needed since

// we are just transfering one zipped file back and forth. I am

// keeping them here for future reference.



/*

HINTERNET FtpFindFirstFileInPath(HINTERNET hConnect,

																 LPCTSTR path,

																 LPCTSTR fileName,

																 LPWIN32_FIND_DATA findData)

{

	DWORD maxPath = MAX_PATH;

	HINTERNET hFind;

	TCHAR currentDir[MAX_PATH];



	// Changing the current directory is a workaround for the fact that

	// FtpFindFirstFile fails if path has a space in it.

	if (!FtpGetCurrentDirectory(hConnect, currentDir, &maxPath) ||

			!FtpSetCurrentDirectory(hConnect, path))

		return NULL;

	hFind = FtpFindFirstFile(hConnect, fileName, findData, 0, 0);

	FtpSetCurrentDirectory(hConnect, currentDir);

	return hFind;

}

*/



/*

BOOL FtpDownload(HINTERNET hConnect, 

								 LPCTSTR sourcePath, 

								 LPCTSTR destPath, 

								 LPCTSTR fileName,

								 BOOL includeDirectories,

								 DWORD *pFilesCopied) {

#define MAX_DIRS 256



	WIN32_FIND_DATA findData;

	HINTERNET hFind;

	TCHAR sourceBuffer[MAX_PATH];

	TCHAR destBuffer[MAX_PATH];

	LPTSTR dirNames[MAX_DIRS];

	int dirs = 0;

	int i;

	DWORD filesCopied;

	BOOL ret;



	if (pFilesCopied)

		*pFilesCopied = 0;



	if (!destPath || !fileName)

		return FALSE;



	if (!sourcePath)

		sourcePath = TEXT(".");



	hFind = FtpFindFirstFileInPath(hConnect, sourcePath, fileName, &findData);

	if (!hFind)

		return TRUE;



	do {

		if (findData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {

			if (includeDirectories && lstrcmp(findData.cFileName, TEXT(".")) && 

				lstrcmp(findData.cFileName, TEXT("..")))

			{

				// We must add the directory name to a list and process it later.

				// This is because an FTP session can only have one active file 

				// enumeration at any one time (see MSDN documentation for 

				// FtpFindFirstFile)

				if (dirs == MAX_DIRS)

					return FALSE;

				dirNames[dirs++] = lstrdup(findData.cFileName);

			}

		}

		else {

			// Download the file

			wsprintf(sourceBuffer, TEXT("%s/%s"), sourcePath, findData.cFileName);

			wsprintf(destBuffer, TEXT("%s\\%s"), destPath, findData.cFileName);

			if (!FtpGetFile(hConnect, sourceBuffer, destBuffer, FALSE, findData.dwFileAttributes, 

					FTP_TRANSFER_TYPE_BINARY | INTERNET_FLAG_RELOAD, 0))

				return FALSE;

			if (pFilesCopied)

				(*pFilesCopied)++;

		}

	} while (InternetFindNextFile(hFind, &findData));



	InternetCloseHandle(hFind);



	// Process directories

	for (i = 0; i < dirs; i++) {

		// Create local directory

		wsprintf(sourceBuffer, TEXT("%s/%s"), sourcePath, dirNames[i]);

		wsprintf(destBuffer, TEXT("%s\\%s"), destPath, dirNames[i]);

		LocalFree(dirNames[i]);

		if (!CreateDirectory(destBuffer, NULL) && GetLastError() != 183) // 183 = directory already exists

			return FALSE;	

		

		// Recursively copy contents of directory

		ret = FtpDownload(hConnect, sourceBuffer, destBuffer, TEXT("*"), TRUE, &filesCopied);

		if (pFilesCopied)

			*pFilesCopied += filesCopied;

		if (!ret)

			return FALSE;

	}



	return TRUE;

}

*/



/*

BOOL FtpUpload(HINTERNET hConnect, 

							LPCTSTR sourcePath,

							LPCTSTR destPath,

							LPCTSTR fileName,

							BOOL includeDirectories,

							DWORD *pFilesCopied)

{

#define MAX_DIRS 256



	WIN32_FIND_DATA findData;

	HANDLE hFind;

	TCHAR sourceBuffer[MAX_PATH];

	TCHAR destBuffer[MAX_PATH];

	DWORD filesCopied;

	BOOL ret;



	if (pFilesCopied)

		*pFilesCopied = 0;



	if (!sourcePath || !fileName)

		return FALSE;



	if (!destPath)

		destPath = TEXT(".");



	wsprintf(sourceBuffer, TEXT("%s\\%s"), sourcePath, fileName);

	hFind = FindFirstFile(sourceBuffer, &findData);

	if (!hFind)

		return TRUE;



	do {

		wsprintf(sourceBuffer, TEXT("%s\\%s"), sourcePath, findData.cFileName);

		wsprintf(destBuffer, TEXT("%s/%s"), destPath, findData.cFileName);



		if (findData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {

			if (includeDirectories && lstrcmp(findData.cFileName, TEXT(".")) && 

				lstrcmp(findData.cFileName, TEXT(".."))) 

			{

				// Create remote directory

				if (!FtpCreateDirectory(hConnect, destBuffer) && GetLastError() != 12003) // 12003 = directory already exists 

					return FALSE;	

		

				// Recursively copy contents of directory

				ret = FtpUpload(hConnect, sourceBuffer, destBuffer, TEXT("*"), TRUE, &filesCopied);

				if (pFilesCopied)

					*pFilesCopied += filesCopied;

				if (!ret)

					return FALSE;

			}

		}

		else {

			// Upload the file

			if (!FtpPutFile(hConnect, sourceBuffer, destBuffer, FTP_TRANSFER_TYPE_BINARY, 0))

				return FALSE;

			if (pFilesCopied)

				(*pFilesCopied)++;

		}

	} while (FindNextFile(hFind, &findData));



	FindClose(hFind);



	return TRUE;

}

*/



/*

BOOL FtpDeleteDirectory(HINTERNET hConnect, LPCTSTR path) {

#define MAX_DIRS 256

	WIN32_FIND_DATA findData;

	HINTERNET hFind;

	TCHAR buffer[MAX_PATH];

	LPTSTR dirNames[MAX_DIRS];

	int dirs = 0;

	int i;

	BOOL fileFound;

	if (!path)

		return TRUE;



	hFind = FtpFindFirstFileInPath(hConnect, path, TEXT("*"), &findData);

	fileFound = (hFind != NULL);



	while (fileFound) {

		if (findData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {

			if (lstrcmp(findData.cFileName, TEXT(".")) && 

				lstrcmp(findData.cFileName, TEXT("..")))

			{

				// We must add the directory name to a list and process it later.

				// This is because an FTP session can only have one active file 

				// enumeration at any one time (see MSDN documentation for 

				// FtpFindFirstFile)

				if (dirs == MAX_DIRS)

					return FALSE;

				dirNames[dirs++] = lstrdup(findData.cFileName);

			}

		}

		else {

			// Delete the file

			wsprintf(buffer, TEXT("%s/%s"), path, findData.cFileName);

			if (!FtpDeleteFile(hConnect, buffer))

				return FALSE;

		}

		fileFound = InternetFindNextFile(hFind, &findData);

	}



	InternetCloseHandle(hFind);



	// Delete subdirectories recursively

	for (i = 0; i < dirs; i++) {

		wsprintf(buffer, TEXT("%s/%s"), path, dirNames[i]);

		LocalFree(dirNames[i]);

		if (!FtpDeleteDirectory(hConnect, buffer))

			return FALSE;	

	}



	// Remove the directory

	return FtpRemoveDirectory(hConnect, path);

}

*/