/*
pGina ldapAuth code - based upon skeleton code for pGina plugin development
Copyright (C) 2002 Micah Cooper

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Email: coopermj@muohio.edu
Snail Mail:
	Micah Cooper
	212A Kreger Hall
	Miami University
	Oxford OH  45056
*/
#pragma once

#include "Resource.h"

// CConfigHooks dialog

class CConfigHooks : public CDialog
{
	DECLARE_DYNAMIC(CConfigHooks)

public:
	CConfigHooks(CWnd* pParent = NULL);   // standard constructor
	virtual ~CConfigHooks();
    void loadListsFromReg(void); // load the lists from the registry
    void saveListsToReg(void); // save the lists to the registry

// Dialog Data
	enum { IDD = IDD_HOOK_TAB };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	CListBox m_LoginHookList;
	CListBox m_LogoutHookList;
	CString m_newLoginHook;
	CString m_newLogoutHook;
	bool hasLoaded;

	afx_msg void OnOK();
	afx_msg void OnAddLoginHook();
	afx_msg void OnRemoveLoginHook();
	afx_msg void OnAddLogoutHook();
	afx_msg void OnRemoveLogoutHook();
	afx_msg void OnSave();
	afx_msg void OnBrowseLogin();
	afx_msg void OnBrowseLogout();
	afx_msg void OnMoveLoginUp();
	afx_msg void OnMoveLoginDown();
	afx_msg void OnMoveLogoutUp();
	afx_msg void OnMoveLogoutDown();
	void swapItem(CListBox *,int, int);
};
