/*
pGina ldapAuth code - based upon skeleton code for pGina plugin development
Copyright (C) 2002 Micah Cooper

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Email: coopermj@muohio.edu
Snail Mail:
	Micah Cooper
	212A Kreger Hall
	Miami University
	Oxford OH  45056
*/
// ConfigUser.cpp : implementation file
//

#include "stdafx.h"
#include "ldapauth_plus.h"
#include "ConfigUser.h"
#include ".\configuser.h"


// CConfigUser dialog

IMPLEMENT_DYNAMIC(CConfigUser, CDialog)
CConfigUser::CConfigUser(CWnd* pParent /*=NULL*/)
	: CDialog(CConfigUser::IDD, pParent)
	, m_NewAdmin(_T(""))
	, m_newUser(_T(""))
{
	hasLoaded = false;
}

CConfigUser::~CConfigUser()
{
}

void CConfigUser::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ADMINLIST, m_AdminList);
	DDX_Text(pDX, IDC_NEWADMIN, m_NewAdmin);
	DDX_Control(pDX, IDC_USERLIST, m_UserList);
	DDX_Text(pDX, IDC_NEWUSER, m_newUser);

	if(!hasLoaded)
	{
		loadListsFromReg();
		hasLoaded = true;
	}
}


BEGIN_MESSAGE_MAP(CConfigUser, CDialog)
	ON_BN_CLICKED(IDC_ADDADMIN, OnAddAdmin)
	ON_BN_CLICKED(IDC_DELETEADMIN, OnRemoveAdmin)
	ON_BN_CLICKED(IDC_ADDUSER, OnAddUser)
	ON_BN_CLICKED(IDC_DELETEUSER, OnRemoveUser)
END_MESSAGE_MAP()


// CConfigUser message handlers
void CConfigUser::OnOK()
{
	return;
}

void CConfigUser::OnAddAdmin()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_NewAdmin == "") {
		MessageBox(L"Please enter a valid username", L"LDAPAuth", MB_OK);
		return;
	}
	m_AdminList.AddString(m_NewAdmin);
	m_NewAdmin = TEXT("");
	UpdateData(FALSE);
}

void CConfigUser::OnRemoveAdmin()
{
	// TODO: Add your control notification handler code here
	if(m_AdminList.GetCurSel() >= 0)
		m_AdminList.DeleteString(m_AdminList.GetCurSel());
}

void CConfigUser::OnAddUser()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_newUser == "") {
		MessageBox(L"Please enter a valid username", L"LDAPAuth", MB_OK);
		return;
	}
	m_UserList.AddString(m_newUser);
	m_newUser = TEXT("");
	UpdateData(FALSE);
}

void CConfigUser::OnRemoveUser()
{
	// TODO: Add your control notification handler code here
	if(m_UserList.GetCurSel() >= 0)
		m_UserList.DeleteString(m_UserList.GetCurSel());
}

void CConfigUser::loadListsFromReg(void)
{
	// Load the content for the lists from the registry 
	WCHAR currentName[256];
	int x = 0;
	CString contextValue = NULL;

	// Then adminOKx
	swprintf(currentName,TEXT("adminOK%d"),x);
	contextValue = regReadString(currentName);
	while(contextValue.GetLength() > 0)
	{
		m_AdminList.AddString(contextValue);
		x++;
        swprintf(currentName,TEXT("adminOK%d"),x);
		contextValue = regReadString(currentName);
	}

	x = 0;
	// Then userOKx
	swprintf(currentName,TEXT("userOK%d"),x);
	contextValue = regReadString(currentName);
	while(contextValue.GetLength() > 0)
	{
		m_UserList.AddString(contextValue);
		x++;
        swprintf(currentName,TEXT("userOK%d"),x);
		contextValue = regReadString(currentName);
	}
}

void CConfigUser::saveListsToReg(void)
{
	WCHAR currentName[256];
	CString value = NULL;
	int x = 0;

	// Now for admin, save them
	for(x = 0; x < m_AdminList.GetCount(); x++)
	{
		m_AdminList.GetText(x,value);
		swprintf(currentName,TEXT("adminOK%d"),x);
		regWriteString(value.GetBuffer(value.GetLength()),currentName);
	}

	// Now loop through and delete any existing contexts above our last saved one
	x = m_AdminList.GetCount();
	swprintf(currentName,TEXT("adminOK%d"),x);
	value = regReadString(currentName);

	while(value.GetLength() > 0)
	{
		regDelValue(currentName);
		x++;
		swprintf(currentName,TEXT("adminOK%d"),x);
		value = regReadString(currentName);
	}

	// then users
	for(x = 0; x < m_UserList.GetCount(); x++)
	{
		m_UserList.GetText(x,value);
		swprintf(currentName,TEXT("userOK%d"),x);
		regWriteString(value.GetBuffer(value.GetLength()),currentName);
	}

	// Now loop through and delete any existing contexts above our last saved one
	x = m_UserList.GetCount();
	swprintf(currentName,TEXT("userOK%d"),x);
	value = regReadString(currentName);

	while(value.GetLength() > 0)
	{
		regDelValue(currentName);
		x++;
		swprintf(currentName,TEXT("userOK%d"),x);
		value = regReadString(currentName);
	}
}

void CConfigUser::OnSave(void)
{
	UpdateData(TRUE);
	WCHAR currentName[256];
	CString value = NULL;
	int x = 0;

	// Now for admin, save them
	for(x = 0; x < m_AdminList.GetCount(); x++)
	{
		m_AdminList.GetText(x,value);
		swprintf(currentName,TEXT("adminOK%d"),x);
		regWriteString(value.GetBuffer(value.GetLength()),currentName);
	}

	// Now loop through and delete any existing contexts above our last saved one
	x = m_AdminList.GetCount();
	swprintf(currentName,TEXT("adminOK%d"),x);
	value = regReadString(currentName);

	while(value.GetLength() > 0)
	{
		regDelValue(currentName);
		x++;
		swprintf(currentName,TEXT("adminOK%d"),x);
		value = regReadString(currentName);
	}

	// then users
	for(x = 0; x < m_UserList.GetCount(); x++)
	{
		m_UserList.GetText(x,value);
		swprintf(currentName,TEXT("userOK%d"),x);
		regWriteString(value.GetBuffer(value.GetLength()),currentName);
	}

	// Now loop through and delete any existing contexts above our last saved one
	x = m_UserList.GetCount();
	swprintf(currentName,TEXT("userOK%d"),x);
	value = regReadString(currentName);

	while(value.GetLength() > 0)
	{
		regDelValue(currentName);
		x++;
		swprintf(currentName,TEXT("userOK%d"),x);
		value = regReadString(currentName);
	}
}
