// ----------------------------------------------------------------------------
// 
// This file contains predefined messages
//
// ----------------------------------------------------------------------------



///////////////////////////////////////////////////////////////////////////////
//
// Information Messages
//
///////////////////////////////////////////////////////////////////////////////

//
//  Values are 32 bit values layed out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-+-----------------------+-------------------------------+
//  |Sev|C|R|     Facility          |               Code            |
//  +---+-+-+-----------------------+-------------------------------+
//
//  where
//
//      Sev - is the severity code
//
//          00 - Success
//          01 - Informational
//          10 - Warning
//          11 - Error
//
//      C - is the Customer code flag
//
//      R - is a reserved bit
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//
//
// Define the facility codes
//


//
// Define the severity codes
//


//
// MessageId: LDAPADMINBINDFAIL
//
// MessageText:
//
//  LDAP Admin bind failed (%1!s!).
//
#define LDAPADMINBINDFAIL                ((DWORD)0xC0000000L)

//
// MessageId: LDAPSEARCHFAIL
//
// MessageText:
//
//  LDAP search failed (%1!s!).
//
#define LDAPSEARCHFAIL                   ((DWORD)0xC0000001L)

//
// MessageId: LDAPFIRSTFIND
//
// MessageText:
//
//  LDAP routine failed to pull first result (data is the LDAP message).
//
#define LDAPFIRSTFIND                    ((DWORD)0xC0000002L)

//
// MessageId: LDAPGETVALFAIL
//
// MessageText:
//
//  LDAP routine failed find the specified value (%1!s!).
//
#define LDAPGETVALFAIL                   ((DWORD)0xC0000003L)

//
// MessageId: LDAPFREEFAIL
//
// MessageText:
//
//  LDAP routine failed to free the message (%1!s!).
//
#define LDAPFREEFAIL                     ((DWORD)0xC0000004L)

//
// MessageId: LDAPBADDN
//
// MessageText:
//
//  The Admin distinguished name has an invalid syntax (%1!s!).
//
#define LDAPBADDN                        ((DWORD)0xC0000005L)

//
// MessageId: LDAPBADCRED
//
// MessageText:
//
//  The supplied Admin credential is invalid. (%1!s!).
//
#define LDAPBADCRED                      ((DWORD)0xC0000006L)

//
// MessageId: LDAPMULTIFAIL
//
// MessageText:
//
//  The specified ldap user failed to login (%1!s!).
//
#define LDAPMULTIFAIL                    ((DWORD)0xC0000007L)

//
// MessageId: LDAPGETOPTFAIL
//
// MessageText:
//
//  The ldap get option call failed (%1!s!).
//
#define LDAPGETOPTFAIL                   ((DWORD)0xC0000008L)

//
// MessageId: LDAPNOSSL
//
// MessageText:
//
//  The server does not support SSL (%1!s!).
//
#define LDAPNOSSL                        ((DWORD)0xC0000009L)

//
// MessageId: LDAPINITFAIL
//
// MessageText:
//
//  Initializing the LDAP connection failed (%1!s!).
//
#define LDAPINITFAIL                     ((DWORD)0xC000000AL)

//
// MessageId: LDAPREGFAIL
//
// MessageText:
//
//  The registry does not appear to be configured correctly.
//
#define LDAPREGFAIL                      ((DWORD)0xC000000BL)