/*

	Copyright (C) 2004 University of Calgary

	

	Contact: Eric Parsons (ericpar@math.ucalgary.ca)



	This file is part of pgftp.



    pgftp is free software; you can redistribute it and/or modify

    it under the terms of the GNU General Public License as published by

    the Free Software Foundation; either version 2 of the License, or

    (at your option) any later version.



    pgftp is distributed in the hope that it will be useful,

    but WITHOUT ANY WARRANTY; without even the implied warranty of

    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

    GNU General Public License for more details.



    You should have received a copy of the GNU General Public License

    along with pgftp; if not, write to the Free Software

    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



 */



#include "stdafx.h"

#include "misc.h"



// See misc.h for function documentation



LPTSTR lstrdup(LPCTSTR str) {

	LPTSTR dup;

	int size = lstrlen(str) + 1;



	if (NULL == str)

		return NULL;



	dup = (TCHAR *)LocalAlloc(LMEM_FIXED, size * sizeof(TCHAR));

	if (dup) 

		lstrcpy(dup, str);



	return dup;

}





LPTSTR GetStringValue(LPCTSTR name)

{

	HKEY hKey = NULL;

	DWORD dwBytesRead = 2048;

	TCHAR result[2048];



	if (ERROR_SUCCESS == RegOpenKeyEx(HKEY_LOCAL_MACHINE, TEXT("Software\\pGina\\pgftp"), 0, KEY_QUERY_VALUE, &hKey))

    if (ERROR_SUCCESS == RegQueryValueEx(hKey, name, NULL, NULL, (LPBYTE)&result, &dwBytesRead)) 

			if (dwBytesRead > 0 && lstrlen(result)) { 

				RegCloseKey(hKey);

				return lstrdup(result);                                                                                 

			}

				

  RegCloseKey(hKey);

  return NULL;

}



DWORD GetIntValue(LPCTSTR name, int defaultValue) {

	HKEY hKey = NULL;

	DWORD result;

	DWORD dwBytesRead = sizeof(result);



	if (ERROR_SUCCESS == RegOpenKeyEx(HKEY_LOCAL_MACHINE, TEXT("Software\\pGina\\pgftp"), 0, KEY_QUERY_VALUE, &hKey))

		if (ERROR_SUCCESS == RegQueryValueEx(hKey, name, NULL, NULL, (LPBYTE)&result, &dwBytesRead)) {

			RegCloseKey(hKey);

			return result;

		}

	RegCloseKey(hKey);

	return defaultValue;

}



LONG SetStringValue(LPCTSTR name, LPCTSTR value)

{

	HKEY hKey = NULL;

	LONG ret;

	

	ret = RegCreateKeyEx(HKEY_LOCAL_MACHINE, TEXT("Software\\pGina\\pgftp"), 0, NULL, 

		REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, NULL, &hKey, NULL);

	if (ret != ERROR_SUCCESS)

		return ret;



	ret = RegSetValueEx(hKey, name, 0, REG_SZ, (LPBYTE)value, (lstrlen(value) + 1) * sizeof(TCHAR));			

  RegCloseKey(hKey);

  return ret;

}



LONG SetIntValue(LPCTSTR name, DWORD value) {

	HKEY hKey = NULL;

	LONG ret;



	ret = RegCreateKeyEx(HKEY_LOCAL_MACHINE, TEXT("Software\\pGina\\pgftp"), 0, NULL,

		REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, NULL, &hKey, NULL);

	if (ret != ERROR_SUCCESS)

		return ret;



	ret = RegSetValueEx(hKey, name, 0, REG_DWORD, (LPBYTE)&value, sizeof(value));			

  RegCloseKey(hKey);

  return ret;

}