/*
pGina Dummy plugin example code - skeleton code for pGina plugin development
*/
// DummyPlugin.cpp : Defines the entry point for the DLL application.
// Sample plugin for pGina Project - For description of methods see
// pGina Plugin Specifications Document or visit us at: http://pgina.cs.plu.edu

#include "stdafx.h"
#include "DummyPlugin.h"
#include <wchar.h>
#include <tchar.h>

// This isn't strictly necessary, but can be handy if you are going to add Dialog's etc
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

/* This is the function that pGina calls to find out whether a user is authorized or not
	it is also the place to put changes in per-user configurations etc. */
DUMMYPLUGIN_API BOOL UserLogin(LPTSTR Username, LPTSTR Password, pGinaInfo *settingsInfo)
{
	// Validate adminuser
	
	if(!_tcscmp(Username,TEXT("adminuser")))
	{
		// This user can change their password
		settingsInfo->allowPassChange = true;
		// This users description
		settingsInfo->userDescription = _tcsdup(TEXT("An admin user for pGina testing"));
		// This users full name
		settingsInfo->userFullName = _tcsdup(TEXT("pGina Administrative User"));
		// This user should be in the Administrator group
		settingsInfo->isAdmin = true;
		// Now let this person in
		return true;
	}

	// Validate reguser
	if(!_tcscmp(Username,TEXT("reguser")))
	{
		// This user can NOT change their password
		settingsInfo->allowPassChange = false;
		// This user should NOT be in the administrator group
		settingsInfo->isAdmin = false;
		// This users description
		settingsInfo->userDescription = _tcsdup(TEXT("A \"normal\" user for pGina testing"));
		// This users full name
		settingsInfo->userFullName = _tcsdup(TEXT("pGina regular User"));
		// If you were to have a local group called "TestUsers" you could add this user with
		//settingsInfo->userGroups = _tcsdup(TEXT("testgroup"));
		// You can add to more than one by seperating them with ;'s..
		// settingsInfo->userGroups = _tcsdup(TEXT("TestUsers;AnotherGroup;TestGroup3"));

		// Now let the user in
		return true;
	}

	if(!_tcscmp(Username,TEXT("otheruser")))
	{
		settingsInfo->isAdmin = false;
		return true;
	}

	// Nobody else gets in, unless they have a local account
	settingsInfo->errorString = _tcsdup(TEXT("The username was not recognized."));
	return false;
}


DUMMYPLUGIN_API BOOL ChangeUserPassword(LPTSTR Username,LPTSTR OldPassword,LPTSTR NewPassword)
{
	return true;
}
DUMMYPLUGIN_API LPCTSTR AboutPlugin(void)
{
	// Return a sample descriptions string
	return TEXT("Dummy plugin example for pGina.  Authenticates adminuser and reguser as well as users with a local machine account.  Created by Nathan Yocom");
}
DUMMYPLUGIN_API void ChangePluginSettings(void)
{
	// Describe in a messagebox what this would do
	MessageBox(NULL,TEXT("This would bring up settings... but this is a simple plugin, so no settings."),TEXT("ChangePluginSettings()"),MB_OK);
}
DUMMYPLUGIN_API void LoginHook(pGinaInfo *settingsInfo)
{
	
}
DUMMYPLUGIN_API void LogoutHook(pGinaInfo *settingsInfo)
{

}

DUMMYPLUGIN_API BOOL IsRequired(void)
{
	return false;
}