// DlgProxy.cpp : implementation file
//

#include "stdafx.h"
#include "tester.h"
#include "DlgProxy.h"
#include "testerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CtesterDlgAutoProxy

IMPLEMENT_DYNCREATE(CtesterDlgAutoProxy, CCmdTarget)

CtesterDlgAutoProxy::CtesterDlgAutoProxy()
{
	EnableAutomation();
	
	// To keep the application running as long as an automation 
	//	object is active, the constructor calls AfxOleLockApp.
	AfxOleLockApp();

	// Get access to the dialog through the application's
	//  main window pointer.  Set the proxy's internal pointer
	//  to point to the dialog, and set the dialog's back pointer to
	//  this proxy.
	ASSERT_VALID(AfxGetApp()->m_pMainWnd);
	if (AfxGetApp()->m_pMainWnd)
	{
		ASSERT_KINDOF(CtesterDlg, AfxGetApp()->m_pMainWnd);
		if (AfxGetApp()->m_pMainWnd->IsKindOf(RUNTIME_CLASS(CtesterDlg)))
		{
			m_pDialog = reinterpret_cast<CtesterDlg*>(AfxGetApp()->m_pMainWnd);
			m_pDialog->m_pAutoProxy = this;
		}
	}
}

CtesterDlgAutoProxy::~CtesterDlgAutoProxy()
{
	// To terminate the application when all objects created with
	// 	with automation, the destructor calls AfxOleUnlockApp.
	//  Among other things, this will destroy the main dialog
	if (m_pDialog != NULL)
		m_pDialog->m_pAutoProxy = NULL;
	AfxOleUnlockApp();
}

void CtesterDlgAutoProxy::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CtesterDlgAutoProxy, CCmdTarget)
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CtesterDlgAutoProxy, CCmdTarget)
END_DISPATCH_MAP()

// Note: we add support for IID_Itester to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .IDL file.

// {5B977DD6-1412-4931-8FAB-C0EBB5324F11}
static const IID IID_Itester =
{ 0x5B977DD6, 0x1412, 0x4931, { 0x8F, 0xAB, 0xC0, 0xEB, 0xB5, 0x32, 0x4F, 0x11 } };

BEGIN_INTERFACE_MAP(CtesterDlgAutoProxy, CCmdTarget)
	INTERFACE_PART(CtesterDlgAutoProxy, IID_Itester, Dispatch)
END_INTERFACE_MAP()

// The IMPLEMENT_OLECREATE2 macro is defined in StdAfx.h of this project
// {45554599-91CD-405E-B3A7-A373E62BC208}
IMPLEMENT_OLECREATE2(CtesterDlgAutoProxy, "tester.Application", 0x45554599, 0x91cd, 0x405e, 0xb3, 0xa7, 0xa3, 0x73, 0xe6, 0x2b, 0xc2, 0x8)


// CtesterDlgAutoProxy message handlers
