/*

	Copyright (C) 2004 University of Calgary

	

	Contact: Eric Parsons (ericpar@math.ucalgary.ca)



	This file is part of pgftp.



    pgftp is free software; you can redistribute it and/or modify

    it under the terms of the GNU General Public License as published by

    the Free Software Foundation; either version 2 of the License, or

    (at your option) any later version.



    pgftp is distributed in the hope that it will be useful,

    but WITHOUT ANY WARRANTY; without even the implied warranty of

    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

    GNU General Public License for more details.



    You should have received a copy of the GNU General Public License

    along with pgftp; if not, write to the Free Software

    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



 */



// The following ifdef block is the standard way of creating macros which make exporting 

// from a DLL simpler. All files within this DLL are compiled with the PGFTP_EXPORTS

// symbol defined on the command line. this symbol should not be defined on any project

// that uses this DLL. This way any other project whose source files include this file see 

// PGFTP_API functions as being imported from a DLL, wheras this DLL sees symbols

// defined with this macro as being exported.

#ifdef PGFTP_EXPORTS

#define PGFTP_API __declspec(dllexport)

#else

#define PGFTP_API __declspec(dllimport)

#endif



#ifdef __cplusplus

extern "C" {

#endif



typedef struct PGINA_INFO {

		LPTSTR pathMSGina;

		LPTSTR pathPlugin;

		LPTSTR pathProfile;

		LPTSTR mapPaths;

		LPTSTR Username;

		LPTSTR Password;

		LPTSTR homeDir;

		BOOL isAdmin;

		BOOL disabled;

		int authType;

		HANDLE hUser;

		LPTSTR userGroups;

		LPTSTR userDescription;

		LPTSTR userFullName;

		BOOL allowPassChange;

		LPTSTR errorString;

		LPTSTR defaultDomain;

		LPTSTR pathProfileDefault;

		BOOL Reserved4;

} PGINA_INFO;



typedef struct {

	HMODULE hModule;

	LPTSTR ftpUserName;

	LPTSTR ftpPassword;

	LPTSTR ftpServer;

	LPTSTR profileTempRoot;

	int compression;

} PLUGIN_SETTINGS;



PGFTP_API BOOL UserLogin(LPTSTR, LPTSTR, PGINA_INFO *);			

PGFTP_API BOOL ChangeUserPassword(LPTSTR,LPTSTR,LPTSTR);

PGFTP_API LPCTSTR AboutPlugin(void);

PGFTP_API void ChangePluginSettings(void);

PGFTP_API void LoginHook(PGINA_INFO *);

PGFTP_API	void LogoutHook(PGINA_INFO *);



// Option method with the 1.6.x series and up of pGina

PGFTP_API BOOL IsRequired(void);



#ifdef __cplusplus

}

#endif



